// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: generator/integration_tests/test2.proto

#include "generator/integration_tests/golden/v1/golden_rest_only_rest_connection.h"
#include "generator/integration_tests/golden/v1/golden_rest_only_options.h"
#include "generator/integration_tests/golden/v1/internal/golden_rest_only_option_defaults.h"
#include "generator/integration_tests/golden/v1/internal/golden_rest_only_rest_connection_impl.h"
#include "generator/integration_tests/golden/v1/internal/golden_rest_only_rest_stub_factory.h"
#include "generator/integration_tests/golden/v1/internal/golden_rest_only_tracing_connection.h"
#include "google/cloud/common_options.h"
#include "google/cloud/credentials.h"
#include "google/cloud/internal/rest_background_threads_impl.h"
#include "google/cloud/internal/rest_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace golden_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

std::shared_ptr<GoldenRestOnlyConnection> MakeGoldenRestOnlyConnectionRest(
    Options options) {
  internal::CheckExpectedOptions<CommonOptionList, RestOptionList,
      UnifiedCredentialsOptionList, rest_internal::TargetApiVersionOption,
      GoldenRestOnlyPolicyOptionList>(options, __func__);
  options = golden_v1_internal::GoldenRestOnlyDefaultOptions(
      std::move(options));
  auto background = std::make_unique<
      rest_internal::AutomaticallyCreatedRestBackgroundThreads>();
  auto stub = golden_v1_internal::CreateDefaultGoldenRestOnlyRestStub(
      options);
  return golden_v1_internal::MakeGoldenRestOnlyTracingConnection(
      std::make_shared<
          golden_v1_internal::GoldenRestOnlyRestConnectionImpl>(
          std::move(background), std::move(stub), std::move(options)));
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace golden_v1
}  // namespace cloud
}  // namespace google
