// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: generator/integration_tests/test_deprecated.proto

#include "generator/integration_tests/golden/v1/internal/deprecated_logging_decorator.h"
#include "google/cloud/internal/log_wrapper.h"
#include "google/cloud/status_or.h"
#include <generator/integration_tests/test_deprecated.grpc.pb.h>
#include <memory>
#include <set>
#include <string>
#include <utility>

namespace google {
namespace cloud {
namespace golden_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

DeprecatedServiceLogging::DeprecatedServiceLogging(
    std::shared_ptr<DeprecatedServiceStub> child,
    TracingOptions tracing_options,
    std::set<std::string> const&)
    : child_(std::move(child)),
      tracing_options_(std::move(tracing_options)) {}

Status
DeprecatedServiceLogging::Noop(
    grpc::ClientContext& context,
    Options const& options,
    google::test::deprecated::v1::DeprecatedServiceRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             Options const& options,
             google::test::deprecated::v1::DeprecatedServiceRequest const& request) {
        return child_->Noop(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace golden_v1_internal
}  // namespace cloud
}  // namespace google
