// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/advisorynotifications/v1/service.proto

#include "google/cloud/advisorynotifications/v1/advisory_notifications_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace advisorynotifications_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

AdvisoryNotificationsServiceConnectionIdempotencyPolicy::
    ~AdvisoryNotificationsServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<AdvisoryNotificationsServiceConnectionIdempotencyPolicy>
AdvisoryNotificationsServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<
      AdvisoryNotificationsServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency
AdvisoryNotificationsServiceConnectionIdempotencyPolicy::ListNotifications(
    google::cloud::advisorynotifications::v1::
        ListNotificationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
AdvisoryNotificationsServiceConnectionIdempotencyPolicy::GetNotification(
    google::cloud::advisorynotifications::v1::GetNotificationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
AdvisoryNotificationsServiceConnectionIdempotencyPolicy::GetSettings(
    google::cloud::advisorynotifications::v1::GetSettingsRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
AdvisoryNotificationsServiceConnectionIdempotencyPolicy::UpdateSettings(
    google::cloud::advisorynotifications::v1::UpdateSettingsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<AdvisoryNotificationsServiceConnectionIdempotencyPolicy>
MakeDefaultAdvisoryNotificationsServiceConnectionIdempotencyPolicy() {
  return std::make_unique<
      AdvisoryNotificationsServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace advisorynotifications_v1
}  // namespace cloud
}  // namespace google
