// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/feature_online_store_service.proto

#include "google/cloud/aiplatform/v1/feature_online_store_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace aiplatform_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

FeatureOnlineStoreServiceConnectionIdempotencyPolicy::
    ~FeatureOnlineStoreServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<FeatureOnlineStoreServiceConnectionIdempotencyPolicy>
FeatureOnlineStoreServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<FeatureOnlineStoreServiceConnectionIdempotencyPolicy>(
      *this);
}

Idempotency
FeatureOnlineStoreServiceConnectionIdempotencyPolicy::FetchFeatureValues(
    google::cloud::aiplatform::v1::FetchFeatureValuesRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
FeatureOnlineStoreServiceConnectionIdempotencyPolicy::SearchNearestEntities(
    google::cloud::aiplatform::v1::SearchNearestEntitiesRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FeatureOnlineStoreServiceConnectionIdempotencyPolicy::ListLocations(
    google::cloud::location::ListLocationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency FeatureOnlineStoreServiceConnectionIdempotencyPolicy::GetLocation(
    google::cloud::location::GetLocationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency FeatureOnlineStoreServiceConnectionIdempotencyPolicy::SetIamPolicy(
    google::iam::v1::SetIamPolicyRequest const& request) {
  return request.policy().etag().empty() ? Idempotency::kNonIdempotent
                                         : Idempotency::kIdempotent;
}

Idempotency FeatureOnlineStoreServiceConnectionIdempotencyPolicy::GetIamPolicy(
    google::iam::v1::GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
FeatureOnlineStoreServiceConnectionIdempotencyPolicy::TestIamPermissions(
    google::iam::v1::TestIamPermissionsRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
FeatureOnlineStoreServiceConnectionIdempotencyPolicy::ListOperations(
    google::longrunning::ListOperationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency FeatureOnlineStoreServiceConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
FeatureOnlineStoreServiceConnectionIdempotencyPolicy::DeleteOperation(
    google::longrunning::DeleteOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
FeatureOnlineStoreServiceConnectionIdempotencyPolicy::CancelOperation(
    google::longrunning::CancelOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FeatureOnlineStoreServiceConnectionIdempotencyPolicy::WaitOperation(
    google::longrunning::WaitOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<FeatureOnlineStoreServiceConnectionIdempotencyPolicy>
MakeDefaultFeatureOnlineStoreServiceConnectionIdempotencyPolicy() {
  return std::make_unique<
      FeatureOnlineStoreServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1
}  // namespace cloud
}  // namespace google
