// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/pipeline_service.proto

#include "google/cloud/aiplatform/v1/pipeline_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace aiplatform_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

PipelineServiceConnectionIdempotencyPolicy::
    ~PipelineServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<PipelineServiceConnectionIdempotencyPolicy>
PipelineServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<PipelineServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::CreateTrainingPipeline(
    google::cloud::aiplatform::v1::CreateTrainingPipelineRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::GetTrainingPipeline(
    google::cloud::aiplatform::v1::GetTrainingPipelineRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::ListTrainingPipelines(
    google::cloud::aiplatform::v1::ListTrainingPipelinesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::DeleteTrainingPipeline(
    google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::CancelTrainingPipeline(
    google::cloud::aiplatform::v1::CancelTrainingPipelineRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::CreatePipelineJob(
    google::cloud::aiplatform::v1::CreatePipelineJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::GetPipelineJob(
    google::cloud::aiplatform::v1::GetPipelineJobRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::ListPipelineJobs(
    google::cloud::aiplatform::v1::ListPipelineJobsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::DeletePipelineJob(
    google::cloud::aiplatform::v1::DeletePipelineJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::BatchDeletePipelineJobs(
    google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::CancelPipelineJob(
    google::cloud::aiplatform::v1::CancelPipelineJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::BatchCancelPipelineJobs(
    google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::ListLocations(
    google::cloud::location::ListLocationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::GetLocation(
    google::cloud::location::GetLocationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::SetIamPolicy(
    google::iam::v1::SetIamPolicyRequest const& request) {
  return request.policy().etag().empty() ? Idempotency::kNonIdempotent
                                         : Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::GetIamPolicy(
    google::iam::v1::GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::TestIamPermissions(
    google::iam::v1::TestIamPermissionsRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::ListOperations(
    google::longrunning::ListOperationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::DeleteOperation(
    google::longrunning::DeleteOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::CancelOperation(
    google::longrunning::CancelOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PipelineServiceConnectionIdempotencyPolicy::WaitOperation(
    google::longrunning::WaitOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<PipelineServiceConnectionIdempotencyPolicy>
MakeDefaultPipelineServiceConnectionIdempotencyPolicy() {
  return std::make_unique<PipelineServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1
}  // namespace cloud
}  // namespace google
