// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/specialist_pool_service.proto

#include "google/cloud/aiplatform/v1/specialist_pool_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace aiplatform_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

SpecialistPoolServiceConnectionIdempotencyPolicy::
    ~SpecialistPoolServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<SpecialistPoolServiceConnectionIdempotencyPolicy>
SpecialistPoolServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<SpecialistPoolServiceConnectionIdempotencyPolicy>(
      *this);
}

Idempotency
SpecialistPoolServiceConnectionIdempotencyPolicy::CreateSpecialistPool(
    google::cloud::aiplatform::v1::CreateSpecialistPoolRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::GetSpecialistPool(
    google::cloud::aiplatform::v1::GetSpecialistPoolRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
SpecialistPoolServiceConnectionIdempotencyPolicy::ListSpecialistPools(
    google::cloud::aiplatform::v1::ListSpecialistPoolsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
SpecialistPoolServiceConnectionIdempotencyPolicy::DeleteSpecialistPool(
    google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
SpecialistPoolServiceConnectionIdempotencyPolicy::UpdateSpecialistPool(
    google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::ListLocations(
    google::cloud::location::ListLocationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::GetLocation(
    google::cloud::location::GetLocationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::SetIamPolicy(
    google::iam::v1::SetIamPolicyRequest const& request) {
  return request.policy().etag().empty() ? Idempotency::kNonIdempotent
                                         : Idempotency::kIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::GetIamPolicy(
    google::iam::v1::GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
SpecialistPoolServiceConnectionIdempotencyPolicy::TestIamPermissions(
    google::iam::v1::TestIamPermissionsRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::ListOperations(
    google::longrunning::ListOperationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::DeleteOperation(
    google::longrunning::DeleteOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::CancelOperation(
    google::longrunning::CancelOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SpecialistPoolServiceConnectionIdempotencyPolicy::WaitOperation(
    google::longrunning::WaitOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<SpecialistPoolServiceConnectionIdempotencyPolicy>
MakeDefaultSpecialistPoolServiceConnectionIdempotencyPolicy() {
  return std::make_unique<SpecialistPoolServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1
}  // namespace cloud
}  // namespace google
