// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/appengine/v1/appengine.proto

#include "google/cloud/appengine/v1/instances_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace appengine_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

InstancesConnectionIdempotencyPolicy::~InstancesConnectionIdempotencyPolicy() =
    default;

std::unique_ptr<InstancesConnectionIdempotencyPolicy>
InstancesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<InstancesConnectionIdempotencyPolicy>(*this);
}

Idempotency InstancesConnectionIdempotencyPolicy::ListInstances(
    google::appengine::v1::ListInstancesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency InstancesConnectionIdempotencyPolicy::GetInstance(
    google::appengine::v1::GetInstanceRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency InstancesConnectionIdempotencyPolicy::DeleteInstance(
    google::appengine::v1::DeleteInstanceRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstancesConnectionIdempotencyPolicy::DebugInstance(
    google::appengine::v1::DebugInstanceRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<InstancesConnectionIdempotencyPolicy>
MakeDefaultInstancesConnectionIdempotencyPolicy() {
  return std::make_unique<InstancesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace appengine_v1
}  // namespace cloud
}  // namespace google
