// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/appengine/v1/appengine.proto

#include "google/cloud/appengine/v1/internal/authorized_domains_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace appengine_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

AuthorizedDomainsTracingConnection::AuthorizedDomainsTracingConnection(
    std::shared_ptr<appengine_v1::AuthorizedDomainsConnection> child)
    : child_(std::move(child)) {}

StreamRange<google::appengine::v1::AuthorizedDomain>
AuthorizedDomainsTracingConnection::ListAuthorizedDomains(
    google::appengine::v1::ListAuthorizedDomainsRequest request) {
  auto span = internal::MakeSpan(
      "appengine_v1::AuthorizedDomainsConnection::ListAuthorizedDomains");
  internal::OTelScope scope(span);
  auto sr = child_->ListAuthorizedDomains(std::move(request));
  return internal::MakeTracedStreamRange<
      google::appengine::v1::AuthorizedDomain>(std::move(span), std::move(sr));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<appengine_v1::AuthorizedDomainsConnection>
MakeAuthorizedDomainsTracingConnection(
    std::shared_ptr<appengine_v1::AuthorizedDomainsConnection> conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn =
        std::make_shared<AuthorizedDomainsTracingConnection>(std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace appengine_v1_internal
}  // namespace cloud
}  // namespace google
