// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/appengine/v1/appengine.proto

#include "google/cloud/appengine/v1/internal/domain_mappings_tracing_stub.h"
#include "google/cloud/internal/grpc_opentelemetry.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace appengine_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

DomainMappingsTracingStub::DomainMappingsTracingStub(
    std::shared_ptr<DomainMappingsStub> child)
    : child_(std::move(child)), propagator_(internal::MakePropagator()) {}

StatusOr<google::appengine::v1::ListDomainMappingsResponse>
DomainMappingsTracingStub::ListDomainMappings(
    grpc::ClientContext& context, Options const& options,
    google::appengine::v1::ListDomainMappingsRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.appengine.v1.DomainMappings",
                                     "ListDomainMappings");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(
      context, *span, child_->ListDomainMappings(context, options, request));
}

StatusOr<google::appengine::v1::DomainMapping>
DomainMappingsTracingStub::GetDomainMapping(
    grpc::ClientContext& context, Options const& options,
    google::appengine::v1::GetDomainMappingRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.appengine.v1.DomainMappings",
                                     "GetDomainMapping");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(context, *span,
                           child_->GetDomainMapping(context, options, request));
}

future<StatusOr<google::longrunning::Operation>>
DomainMappingsTracingStub::AsyncCreateDomainMapping(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::appengine::v1::CreateDomainMappingRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.appengine.v1.DomainMappings",
                                     "CreateDomainMapping");
  internal::OTelScope scope(span);
  internal::InjectTraceContext(*context, *propagator_);
  auto f = child_->AsyncCreateDomainMapping(cq, context, std::move(options),
                                            request);
  return internal::EndSpan(std::move(context), std::move(span), std::move(f));
}

StatusOr<google::longrunning::Operation>
DomainMappingsTracingStub::CreateDomainMapping(
    grpc::ClientContext& context, Options options,
    google::appengine::v1::CreateDomainMappingRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.appengine.v1.DomainMappings",
                                     "CreateDomainMapping");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(
      context, *span, child_->CreateDomainMapping(context, options, request));
}

future<StatusOr<google::longrunning::Operation>>
DomainMappingsTracingStub::AsyncUpdateDomainMapping(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::appengine::v1::UpdateDomainMappingRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.appengine.v1.DomainMappings",
                                     "UpdateDomainMapping");
  internal::OTelScope scope(span);
  internal::InjectTraceContext(*context, *propagator_);
  auto f = child_->AsyncUpdateDomainMapping(cq, context, std::move(options),
                                            request);
  return internal::EndSpan(std::move(context), std::move(span), std::move(f));
}

StatusOr<google::longrunning::Operation>
DomainMappingsTracingStub::UpdateDomainMapping(
    grpc::ClientContext& context, Options options,
    google::appengine::v1::UpdateDomainMappingRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.appengine.v1.DomainMappings",
                                     "UpdateDomainMapping");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(
      context, *span, child_->UpdateDomainMapping(context, options, request));
}

future<StatusOr<google::longrunning::Operation>>
DomainMappingsTracingStub::AsyncDeleteDomainMapping(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::appengine::v1::DeleteDomainMappingRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.appengine.v1.DomainMappings",
                                     "DeleteDomainMapping");
  internal::OTelScope scope(span);
  internal::InjectTraceContext(*context, *propagator_);
  auto f = child_->AsyncDeleteDomainMapping(cq, context, std::move(options),
                                            request);
  return internal::EndSpan(std::move(context), std::move(span), std::move(f));
}

StatusOr<google::longrunning::Operation>
DomainMappingsTracingStub::DeleteDomainMapping(
    grpc::ClientContext& context, Options options,
    google::appengine::v1::DeleteDomainMappingRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.appengine.v1.DomainMappings",
                                     "DeleteDomainMapping");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(
      context, *span, child_->DeleteDomainMapping(context, options, request));
}

future<StatusOr<google::longrunning::Operation>>
DomainMappingsTracingStub::AsyncGetOperation(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::longrunning::GetOperationRequest const& request) {
  auto span =
      internal::MakeSpanGrpc("google.longrunning.Operations", "GetOperation");
  internal::OTelScope scope(span);
  internal::InjectTraceContext(*context, *propagator_);
  auto f = child_->AsyncGetOperation(cq, context, std::move(options), request);
  return internal::EndSpan(std::move(context), std::move(span), std::move(f));
}

future<Status> DomainMappingsTracingStub::AsyncCancelOperation(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::longrunning::CancelOperationRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.longrunning.Operations",
                                     "CancelOperation");
  internal::OTelScope scope(span);
  internal::InjectTraceContext(*context, *propagator_);
  auto f =
      child_->AsyncCancelOperation(cq, context, std::move(options), request);
  return internal::EndSpan(std::move(context), std::move(span), std::move(f));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<DomainMappingsStub> MakeDomainMappingsTracingStub(
    std::shared_ptr<DomainMappingsStub> stub) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return std::make_shared<DomainMappingsTracingStub>(std::move(stub));
#else
  return stub;
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace appengine_v1_internal
}  // namespace cloud
}  // namespace google
