// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/appengine/v1/appengine.proto

#include "google/cloud/appengine/v1/services_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace appengine_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ServicesConnectionIdempotencyPolicy::~ServicesConnectionIdempotencyPolicy() =
    default;

std::unique_ptr<ServicesConnectionIdempotencyPolicy>
ServicesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<ServicesConnectionIdempotencyPolicy>(*this);
}

Idempotency ServicesConnectionIdempotencyPolicy::ListServices(
    google::appengine::v1::ListServicesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency ServicesConnectionIdempotencyPolicy::GetService(
    google::appengine::v1::GetServiceRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency ServicesConnectionIdempotencyPolicy::UpdateService(
    google::appengine::v1::UpdateServiceRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ServicesConnectionIdempotencyPolicy::DeleteService(
    google::appengine::v1::DeleteServiceRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<ServicesConnectionIdempotencyPolicy>
MakeDefaultServicesConnectionIdempotencyPolicy() {
  return std::make_unique<ServicesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace appengine_v1
}  // namespace cloud
}  // namespace google
