// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/assuredworkloads/v1/assuredworkloads.proto

#include "google/cloud/assuredworkloads/v1/internal/assured_workloads_option_defaults.h"
#include "google/cloud/assuredworkloads/v1/assured_workloads_connection.h"
#include "google/cloud/assuredworkloads/v1/assured_workloads_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace assuredworkloads_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options AssuredWorkloadsServiceDefaultOptions(Options options) {
  options = internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_ASSURED_WORKLOADS_SERVICE_ENDPOINT",
      "", "GOOGLE_CLOUD_CPP_ASSURED_WORKLOADS_SERVICE_AUTHORITY",
      "assuredworkloads.googleapis.com");
  options = internal::PopulateGrpcOptions(std::move(options));
  if (!options.has<
          assuredworkloads_v1::AssuredWorkloadsServiceRetryPolicyOption>()) {
    options.set<assuredworkloads_v1::AssuredWorkloadsServiceRetryPolicyOption>(
        assuredworkloads_v1::AssuredWorkloadsServiceLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<
          assuredworkloads_v1::AssuredWorkloadsServiceBackoffPolicyOption>()) {
    options
        .set<assuredworkloads_v1::AssuredWorkloadsServiceBackoffPolicyOption>(
            ExponentialBackoffPolicy(
                std::chrono::seconds(0), std::chrono::seconds(1),
                std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
                .clone());
  }
  if (!options.has<
          assuredworkloads_v1::AssuredWorkloadsServicePollingPolicyOption>()) {
    options.set<
        assuredworkloads_v1::AssuredWorkloadsServicePollingPolicyOption>(
        GenericPollingPolicy<
            assuredworkloads_v1::AssuredWorkloadsServiceRetryPolicyOption::Type,
            assuredworkloads_v1::AssuredWorkloadsServiceBackoffPolicyOption::
                Type>(
            options
                .get<assuredworkloads_v1::
                         AssuredWorkloadsServiceRetryPolicyOption>()
                ->clone(),
            ExponentialBackoffPolicy(std::chrono::seconds(1),
                                     std::chrono::minutes(5), kBackoffScaling)
                .clone())
            .clone());
  }
  if (!options.has<
          assuredworkloads_v1::
              AssuredWorkloadsServiceConnectionIdempotencyPolicyOption>()) {
    options.set<assuredworkloads_v1::
                    AssuredWorkloadsServiceConnectionIdempotencyPolicyOption>(
        assuredworkloads_v1::
            MakeDefaultAssuredWorkloadsServiceConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace assuredworkloads_v1_internal
}  // namespace cloud
}  // namespace google
