// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/bigquery/storage/v1/storage.proto

#include "google/cloud/bigquery/storage/v1/bigquery_read_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace bigquery_storage_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

BigQueryReadConnectionIdempotencyPolicy::
    ~BigQueryReadConnectionIdempotencyPolicy() = default;

std::unique_ptr<BigQueryReadConnectionIdempotencyPolicy>
BigQueryReadConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<BigQueryReadConnectionIdempotencyPolicy>(*this);
}

Idempotency BigQueryReadConnectionIdempotencyPolicy::CreateReadSession(
    google::cloud::bigquery::storage::v1::CreateReadSessionRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency BigQueryReadConnectionIdempotencyPolicy::SplitReadStream(
    google::cloud::bigquery::storage::v1::SplitReadStreamRequest const&) {
  return Idempotency::kIdempotent;
}

std::unique_ptr<BigQueryReadConnectionIdempotencyPolicy>
MakeDefaultBigQueryReadConnectionIdempotencyPolicy() {
  return std::make_unique<BigQueryReadConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace bigquery_storage_v1
}  // namespace cloud
}  // namespace google
