// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/bigquery/v2/job.proto

#include "google/cloud/bigquerycontrol/v2/job_connection.h"
#include "google/cloud/bigquerycontrol/v2/internal/job_option_defaults.h"
#include "google/cloud/bigquerycontrol/v2/internal/job_tracing_connection.h"
#include "google/cloud/bigquerycontrol/v2/job_options.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/common_options.h"
#include "google/cloud/credentials.h"
#include "google/cloud/grpc_options.h"
#include "google/cloud/internal/pagination_range.h"
#include "google/cloud/internal/unified_grpc_credentials.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace bigquerycontrol_v2 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

JobServiceConnection::~JobServiceConnection() = default;

StatusOr<google::cloud::bigquery::v2::JobCancelResponse>
JobServiceConnection::CancelJob(
    google::cloud::bigquery::v2::CancelJobRequest const&) {
  return Status(StatusCode::kUnimplemented, "not implemented");
}

StatusOr<google::cloud::bigquery::v2::Job> JobServiceConnection::GetJob(
    google::cloud::bigquery::v2::GetJobRequest const&) {
  return Status(StatusCode::kUnimplemented, "not implemented");
}

StatusOr<google::cloud::bigquery::v2::Job> JobServiceConnection::InsertJob(
    google::cloud::bigquery::v2::InsertJobRequest const&) {
  return Status(StatusCode::kUnimplemented, "not implemented");
}

Status JobServiceConnection::DeleteJob(
    google::cloud::bigquery::v2::DeleteJobRequest const&) {
  return Status(StatusCode::kUnimplemented, "not implemented");
}

StreamRange<google::cloud::bigquery::v2::ListFormatJob>
JobServiceConnection::ListJobs(
    google::cloud::bigquery::v2::
        ListJobsRequest) {  // NOLINT(performance-unnecessary-value-param)
  return google::cloud::internal::MakeUnimplementedPaginationRange<
      StreamRange<google::cloud::bigquery::v2::ListFormatJob>>();
}

StatusOr<google::cloud::bigquery::v2::GetQueryResultsResponse>
JobServiceConnection::GetQueryResults(
    google::cloud::bigquery::v2::GetQueryResultsRequest const&) {
  return Status(StatusCode::kUnimplemented, "not implemented");
}

StatusOr<google::cloud::bigquery::v2::QueryResponse>
JobServiceConnection::Query(
    google::cloud::bigquery::v2::PostQueryRequest const&) {
  return Status(StatusCode::kUnimplemented, "not implemented");
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace bigquerycontrol_v2
}  // namespace cloud
}  // namespace google
