// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/billing/budgets/v1/budget_service.proto

#include "google/cloud/billing/budgets/v1/internal/budget_auth_decorator.h"
#include <google/cloud/billing/budgets/v1/budget_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace billing_budgets_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

BudgetServiceAuth::BudgetServiceAuth(
    std::shared_ptr<google::cloud::internal::GrpcAuthenticationStrategy> auth,
    std::shared_ptr<BudgetServiceStub> child)
    : auth_(std::move(auth)), child_(std::move(child)) {}

StatusOr<google::cloud::billing::budgets::v1::Budget>
BudgetServiceAuth::CreateBudget(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::CreateBudgetRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->CreateBudget(context, options, request);
}

StatusOr<google::cloud::billing::budgets::v1::Budget>
BudgetServiceAuth::UpdateBudget(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::UpdateBudgetRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->UpdateBudget(context, options, request);
}

StatusOr<google::cloud::billing::budgets::v1::Budget>
BudgetServiceAuth::GetBudget(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::GetBudgetRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->GetBudget(context, options, request);
}

StatusOr<google::cloud::billing::budgets::v1::ListBudgetsResponse>
BudgetServiceAuth::ListBudgets(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::ListBudgetsRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->ListBudgets(context, options, request);
}

Status BudgetServiceAuth::DeleteBudget(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::DeleteBudgetRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->DeleteBudget(context, options, request);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace billing_budgets_v1_internal
}  // namespace cloud
}  // namespace google
