// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/billing/budgets/v1/budget_service.proto

#include "google/cloud/billing/budgets/v1/internal/budget_logging_decorator.h"
#include "google/cloud/internal/log_wrapper.h"
#include "google/cloud/status_or.h"
#include <google/cloud/billing/budgets/v1/budget_service.grpc.pb.h>
#include <memory>
#include <set>
#include <string>
#include <utility>

namespace google {
namespace cloud {
namespace billing_budgets_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

BudgetServiceLogging::BudgetServiceLogging(
    std::shared_ptr<BudgetServiceStub> child, TracingOptions tracing_options,
    std::set<std::string> const&)
    : child_(std::move(child)), tracing_options_(std::move(tracing_options)) {}

StatusOr<google::cloud::billing::budgets::v1::Budget>
BudgetServiceLogging::CreateBudget(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::CreateBudgetRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::billing::budgets::v1::CreateBudgetRequest const&
                 request) {
        return child_->CreateBudget(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::billing::budgets::v1::Budget>
BudgetServiceLogging::UpdateBudget(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::UpdateBudgetRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::billing::budgets::v1::UpdateBudgetRequest const&
                 request) {
        return child_->UpdateBudget(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::billing::budgets::v1::Budget>
BudgetServiceLogging::GetBudget(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::GetBudgetRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::billing::budgets::v1::GetBudgetRequest const&
                 request) {
        return child_->GetBudget(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::billing::budgets::v1::ListBudgetsResponse>
BudgetServiceLogging::ListBudgets(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::ListBudgetsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::billing::budgets::v1::ListBudgetsRequest const&
                 request) {
        return child_->ListBudgets(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

Status BudgetServiceLogging::DeleteBudget(
    grpc::ClientContext& context, Options const& options,
    google::cloud::billing::budgets::v1::DeleteBudgetRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::billing::budgets::v1::DeleteBudgetRequest const&
                 request) {
        return child_->DeleteBudget(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace billing_budgets_v1_internal
}  // namespace cloud
}  // namespace google
