// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/binaryauthorization/v1/service.proto

#include "google/cloud/binaryauthorization/v1/internal/binauthz_management_service_v1_logging_decorator.h"
#include "google/cloud/internal/log_wrapper.h"
#include "google/cloud/status_or.h"
#include <google/cloud/binaryauthorization/v1/service.grpc.pb.h>
#include <memory>
#include <set>
#include <string>
#include <utility>

namespace google {
namespace cloud {
namespace binaryauthorization_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

BinauthzManagementServiceV1Logging::BinauthzManagementServiceV1Logging(
    std::shared_ptr<BinauthzManagementServiceV1Stub> child,
    TracingOptions tracing_options, std::set<std::string> const&)
    : child_(std::move(child)), tracing_options_(std::move(tracing_options)) {}

StatusOr<google::cloud::binaryauthorization::v1::Policy>
BinauthzManagementServiceV1Logging::GetPolicy(
    grpc::ClientContext& context, Options const& options,
    google::cloud::binaryauthorization::v1::GetPolicyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::binaryauthorization::v1::GetPolicyRequest const&
                 request) {
        return child_->GetPolicy(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::binaryauthorization::v1::Policy>
BinauthzManagementServiceV1Logging::UpdatePolicy(
    grpc::ClientContext& context, Options const& options,
    google::cloud::binaryauthorization::v1::UpdatePolicyRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::binaryauthorization::v1::UpdatePolicyRequest const&
                 request) {
        return child_->UpdatePolicy(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::binaryauthorization::v1::Attestor>
BinauthzManagementServiceV1Logging::CreateAttestor(
    grpc::ClientContext& context, Options const& options,
    google::cloud::binaryauthorization::v1::CreateAttestorRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::binaryauthorization::v1::CreateAttestorRequest const&
              request) {
        return child_->CreateAttestor(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::binaryauthorization::v1::Attestor>
BinauthzManagementServiceV1Logging::GetAttestor(
    grpc::ClientContext& context, Options const& options,
    google::cloud::binaryauthorization::v1::GetAttestorRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::binaryauthorization::v1::GetAttestorRequest const&
                 request) {
        return child_->GetAttestor(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::binaryauthorization::v1::Attestor>
BinauthzManagementServiceV1Logging::UpdateAttestor(
    grpc::ClientContext& context, Options const& options,
    google::cloud::binaryauthorization::v1::UpdateAttestorRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::binaryauthorization::v1::UpdateAttestorRequest const&
              request) {
        return child_->UpdateAttestor(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::binaryauthorization::v1::ListAttestorsResponse>
BinauthzManagementServiceV1Logging::ListAttestors(
    grpc::ClientContext& context, Options const& options,
    google::cloud::binaryauthorization::v1::ListAttestorsRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::binaryauthorization::v1::ListAttestorsRequest const&
                 request) {
        return child_->ListAttestors(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

Status BinauthzManagementServiceV1Logging::DeleteAttestor(
    grpc::ClientContext& context, Options const& options,
    google::cloud::binaryauthorization::v1::DeleteAttestorRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::binaryauthorization::v1::DeleteAttestorRequest const&
              request) {
        return child_->DeleteAttestor(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace binaryauthorization_v1_internal
}  // namespace cloud
}  // namespace google
