// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/channel/v1/reports_service.proto

#include "google/cloud/channel/v1/cloud_channel_reports_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace channel_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

CloudChannelReportsServiceConnectionIdempotencyPolicy::
    ~CloudChannelReportsServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<CloudChannelReportsServiceConnectionIdempotencyPolicy>
CloudChannelReportsServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<
      CloudChannelReportsServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency CloudChannelReportsServiceConnectionIdempotencyPolicy::RunReportJob(
    google::cloud::channel::v1::RunReportJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
CloudChannelReportsServiceConnectionIdempotencyPolicy::FetchReportResults(
    google::cloud::channel::v1::FetchReportResultsRequest) {  // NOLINT
  return Idempotency::kNonIdempotent;
}

Idempotency CloudChannelReportsServiceConnectionIdempotencyPolicy::ListReports(
    google::cloud::channel::v1::ListReportsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
CloudChannelReportsServiceConnectionIdempotencyPolicy::ListOperations(
    google::longrunning::ListOperationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency CloudChannelReportsServiceConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
CloudChannelReportsServiceConnectionIdempotencyPolicy::DeleteOperation(
    google::longrunning::DeleteOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
CloudChannelReportsServiceConnectionIdempotencyPolicy::CancelOperation(
    google::longrunning::CancelOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<CloudChannelReportsServiceConnectionIdempotencyPolicy>
MakeDefaultCloudChannelReportsServiceConnectionIdempotencyPolicy() {
  return std::make_unique<
      CloudChannelReportsServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace channel_v1
}  // namespace cloud
}  // namespace google
