// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/devtools/cloudbuild/v2/repositories.proto

#include "google/cloud/cloudbuild/v2/internal/repository_manager_option_defaults.h"
#include "google/cloud/cloudbuild/v2/repository_manager_connection.h"
#include "google/cloud/cloudbuild/v2/repository_manager_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace cloudbuild_v2_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options RepositoryManagerDefaultOptions(Options options) {
  options = internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_REPOSITORY_MANAGER_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_REPOSITORY_MANAGER_AUTHORITY",
      "cloudbuild.googleapis.com");
  options = internal::PopulateGrpcOptions(std::move(options));
  if (!options.has<cloudbuild_v2::RepositoryManagerRetryPolicyOption>()) {
    options.set<cloudbuild_v2::RepositoryManagerRetryPolicyOption>(
        cloudbuild_v2::RepositoryManagerLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<cloudbuild_v2::RepositoryManagerBackoffPolicyOption>()) {
    options.set<cloudbuild_v2::RepositoryManagerBackoffPolicyOption>(
        ExponentialBackoffPolicy(
            std::chrono::seconds(0), std::chrono::seconds(1),
            std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
            .clone());
  }
  if (!options.has<cloudbuild_v2::RepositoryManagerPollingPolicyOption>()) {
    options.set<cloudbuild_v2::RepositoryManagerPollingPolicyOption>(
        GenericPollingPolicy<
            cloudbuild_v2::RepositoryManagerRetryPolicyOption::Type,
            cloudbuild_v2::RepositoryManagerBackoffPolicyOption::Type>(
            options.get<cloudbuild_v2::RepositoryManagerRetryPolicyOption>()
                ->clone(),
            ExponentialBackoffPolicy(std::chrono::seconds(1),
                                     std::chrono::minutes(5), kBackoffScaling)
                .clone())
            .clone());
  }
  if (!options.has<cloudbuild_v2::
                       RepositoryManagerConnectionIdempotencyPolicyOption>()) {
    options
        .set<cloudbuild_v2::RepositoryManagerConnectionIdempotencyPolicyOption>(
            cloudbuild_v2::
                MakeDefaultRepositoryManagerConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace cloudbuild_v2_internal
}  // namespace cloud
}  // namespace google
