// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/api/cloudquotas/v1/cloudquotas.proto

#include "google/cloud/cloudquotas/v1/internal/cloud_quotas_auth_decorator.h"
#include <google/api/cloudquotas/v1/cloudquotas.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace cloudquotas_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

CloudQuotasAuth::CloudQuotasAuth(
    std::shared_ptr<google::cloud::internal::GrpcAuthenticationStrategy> auth,
    std::shared_ptr<CloudQuotasStub> child)
    : auth_(std::move(auth)), child_(std::move(child)) {}

StatusOr<google::api::cloudquotas::v1::ListQuotaInfosResponse>
CloudQuotasAuth::ListQuotaInfos(
    grpc::ClientContext& context, Options const& options,
    google::api::cloudquotas::v1::ListQuotaInfosRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->ListQuotaInfos(context, options, request);
}

StatusOr<google::api::cloudquotas::v1::QuotaInfo> CloudQuotasAuth::GetQuotaInfo(
    grpc::ClientContext& context, Options const& options,
    google::api::cloudquotas::v1::GetQuotaInfoRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->GetQuotaInfo(context, options, request);
}

StatusOr<google::api::cloudquotas::v1::ListQuotaPreferencesResponse>
CloudQuotasAuth::ListQuotaPreferences(
    grpc::ClientContext& context, Options const& options,
    google::api::cloudquotas::v1::ListQuotaPreferencesRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->ListQuotaPreferences(context, options, request);
}

StatusOr<google::api::cloudquotas::v1::QuotaPreference>
CloudQuotasAuth::GetQuotaPreference(
    grpc::ClientContext& context, Options const& options,
    google::api::cloudquotas::v1::GetQuotaPreferenceRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->GetQuotaPreference(context, options, request);
}

StatusOr<google::api::cloudquotas::v1::QuotaPreference>
CloudQuotasAuth::CreateQuotaPreference(
    grpc::ClientContext& context, Options const& options,
    google::api::cloudquotas::v1::CreateQuotaPreferenceRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->CreateQuotaPreference(context, options, request);
}

StatusOr<google::api::cloudquotas::v1::QuotaPreference>
CloudQuotasAuth::UpdateQuotaPreference(
    grpc::ClientContext& context, Options const& options,
    google::api::cloudquotas::v1::UpdateQuotaPreferenceRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->UpdateQuotaPreference(context, options, request);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace cloudquotas_v1_internal
}  // namespace cloud
}  // namespace google
