// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/disk_types/v1/disk_types.proto

#include "google/cloud/compute/disk_types/v1/disk_types_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_disk_types_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

DiskTypesConnectionIdempotencyPolicy::~DiskTypesConnectionIdempotencyPolicy() =
    default;

std::unique_ptr<DiskTypesConnectionIdempotencyPolicy>
DiskTypesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<DiskTypesConnectionIdempotencyPolicy>(*this);
}

Idempotency DiskTypesConnectionIdempotencyPolicy::AggregatedListDiskTypes(
    google::cloud::cpp::compute::disk_types::v1::
        AggregatedListDiskTypesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency DiskTypesConnectionIdempotencyPolicy::GetDiskType(
    google::cloud::cpp::compute::disk_types::v1::GetDiskTypeRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency DiskTypesConnectionIdempotencyPolicy::ListDiskTypes(
    google::cloud::cpp::compute::disk_types::v1::
        ListDiskTypesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

std::unique_ptr<DiskTypesConnectionIdempotencyPolicy>
MakeDefaultDiskTypesConnectionIdempotencyPolicy() {
  return std::make_unique<DiskTypesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_disk_types_v1
}  // namespace cloud
}  // namespace google
