// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/firewall_policies/v1/firewall_policies.proto

#include "google/cloud/compute/firewall_policies/v1/firewall_policies_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_firewall_policies_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

FirewallPoliciesConnectionIdempotencyPolicy::
    ~FirewallPoliciesConnectionIdempotencyPolicy() = default;

std::unique_ptr<FirewallPoliciesConnectionIdempotencyPolicy>
FirewallPoliciesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<FirewallPoliciesConnectionIdempotencyPolicy>(*this);
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::AddAssociation(
    google::cloud::cpp::compute::firewall_policies::v1::
        AddAssociationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::AddRule(
    google::cloud::cpp::compute::firewall_policies::v1::AddRuleRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::CloneRules(
    google::cloud::cpp::compute::firewall_policies::v1::
        CloneRulesRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::DeleteFirewallPolicy(
    google::cloud::cpp::compute::firewall_policies::v1::
        DeleteFirewallPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::GetFirewallPolicy(
    google::cloud::cpp::compute::firewall_policies::v1::
        GetFirewallPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::GetAssociation(
    google::cloud::cpp::compute::firewall_policies::v1::
        GetAssociationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::GetIamPolicy(
    google::cloud::cpp::compute::firewall_policies::v1::
        GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::GetRule(
    google::cloud::cpp::compute::firewall_policies::v1::GetRuleRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::InsertFirewallPolicy(
    google::cloud::cpp::compute::firewall_policies::v1::
        InsertFirewallPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::ListFirewallPolicies(
    google::cloud::cpp::compute::firewall_policies::v1::
        ListFirewallPoliciesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::ListAssociations(
    google::cloud::cpp::compute::firewall_policies::v1::
        ListAssociationsRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::Move(
    google::cloud::cpp::compute::firewall_policies::v1::MoveRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::PatchFirewallPolicy(
    google::cloud::cpp::compute::firewall_policies::v1::
        PatchFirewallPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::PatchRule(
    google::cloud::cpp::compute::firewall_policies::v1::
        PatchRuleRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::RemoveAssociation(
    google::cloud::cpp::compute::firewall_policies::v1::
        RemoveAssociationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::RemoveRule(
    google::cloud::cpp::compute::firewall_policies::v1::
        RemoveRuleRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::SetIamPolicy(
    google::cloud::cpp::compute::firewall_policies::v1::
        SetIamPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FirewallPoliciesConnectionIdempotencyPolicy::TestIamPermissions(
    google::cloud::cpp::compute::firewall_policies::v1::
        TestIamPermissionsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<FirewallPoliciesConnectionIdempotencyPolicy>
MakeDefaultFirewallPoliciesConnectionIdempotencyPolicy() {
  return std::make_unique<FirewallPoliciesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_firewall_policies_v1
}  // namespace cloud
}  // namespace google
