// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/global_network_endpoint_groups/v1/global_network_endpoint_groups.proto

#include "google/cloud/compute/global_network_endpoint_groups/v1/internal/global_network_endpoint_groups_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_global_network_endpoint_groups_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

GlobalNetworkEndpointGroupsTracingConnection::
    GlobalNetworkEndpointGroupsTracingConnection(
        std::shared_ptr<compute_global_network_endpoint_groups_v1::
                            GlobalNetworkEndpointGroupsConnection>
            child)
    : child_(std::move(child)) {}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
GlobalNetworkEndpointGroupsTracingConnection::AttachNetworkEndpoints(
    google::cloud::cpp::compute::global_network_endpoint_groups::v1::
        AttachNetworkEndpointsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::AttachNetworkEndpoints");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->AttachNetworkEndpoints(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
GlobalNetworkEndpointGroupsTracingConnection::AttachNetworkEndpoints(
    NoAwaitTag, google::cloud::cpp::compute::global_network_endpoint_groups::
                    v1::AttachNetworkEndpointsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::AttachNetworkEndpoints");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(
      *span, child_->AttachNetworkEndpoints(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
GlobalNetworkEndpointGroupsTracingConnection::AttachNetworkEndpoints(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::AttachNetworkEndpoints");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->AttachNetworkEndpoints(operation));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
GlobalNetworkEndpointGroupsTracingConnection::DeleteNetworkEndpointGroup(
    google::cloud::cpp::compute::global_network_endpoint_groups::v1::
        DeleteNetworkEndpointGroupRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::DeleteNetworkEndpointGroup");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteNetworkEndpointGroup(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
GlobalNetworkEndpointGroupsTracingConnection::DeleteNetworkEndpointGroup(
    NoAwaitTag, google::cloud::cpp::compute::global_network_endpoint_groups::
                    v1::DeleteNetworkEndpointGroupRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::DeleteNetworkEndpointGroup");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(
      *span, child_->DeleteNetworkEndpointGroup(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
GlobalNetworkEndpointGroupsTracingConnection::DeleteNetworkEndpointGroup(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::DeleteNetworkEndpointGroup");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteNetworkEndpointGroup(operation));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
GlobalNetworkEndpointGroupsTracingConnection::DetachNetworkEndpoints(
    google::cloud::cpp::compute::global_network_endpoint_groups::v1::
        DetachNetworkEndpointsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::DetachNetworkEndpoints");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DetachNetworkEndpoints(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
GlobalNetworkEndpointGroupsTracingConnection::DetachNetworkEndpoints(
    NoAwaitTag, google::cloud::cpp::compute::global_network_endpoint_groups::
                    v1::DetachNetworkEndpointsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::DetachNetworkEndpoints");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(
      *span, child_->DetachNetworkEndpoints(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
GlobalNetworkEndpointGroupsTracingConnection::DetachNetworkEndpoints(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::DetachNetworkEndpoints");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DetachNetworkEndpoints(operation));
}

StatusOr<google::cloud::cpp::compute::v1::NetworkEndpointGroup>
GlobalNetworkEndpointGroupsTracingConnection::GetNetworkEndpointGroup(
    google::cloud::cpp::compute::global_network_endpoint_groups::v1::
        GetNetworkEndpointGroupRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::GetNetworkEndpointGroup");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetNetworkEndpointGroup(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
GlobalNetworkEndpointGroupsTracingConnection::InsertNetworkEndpointGroup(
    google::cloud::cpp::compute::global_network_endpoint_groups::v1::
        InsertNetworkEndpointGroupRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::InsertNetworkEndpointGroup");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertNetworkEndpointGroup(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
GlobalNetworkEndpointGroupsTracingConnection::InsertNetworkEndpointGroup(
    NoAwaitTag, google::cloud::cpp::compute::global_network_endpoint_groups::
                    v1::InsertNetworkEndpointGroupRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::InsertNetworkEndpointGroup");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(
      *span, child_->InsertNetworkEndpointGroup(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
GlobalNetworkEndpointGroupsTracingConnection::InsertNetworkEndpointGroup(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::InsertNetworkEndpointGroup");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertNetworkEndpointGroup(operation));
}

StreamRange<google::cloud::cpp::compute::v1::NetworkEndpointGroup>
GlobalNetworkEndpointGroupsTracingConnection::ListGlobalNetworkEndpointGroups(
    google::cloud::cpp::compute::global_network_endpoint_groups::v1::
        ListGlobalNetworkEndpointGroupsRequest request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::ListGlobalNetworkEndpointGroups");
  internal::OTelScope scope(span);
  auto sr = child_->ListGlobalNetworkEndpointGroups(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::cpp::compute::v1::NetworkEndpointGroup>(std::move(span),
                                                             std::move(sr));
}

StreamRange<google::cloud::cpp::compute::v1::NetworkEndpointWithHealthStatus>
GlobalNetworkEndpointGroupsTracingConnection::ListNetworkEndpoints(
    google::cloud::cpp::compute::global_network_endpoint_groups::v1::
        ListNetworkEndpointsRequest request) {
  auto span = internal::MakeSpan(
      "compute_global_network_endpoint_groups_v1::"
      "GlobalNetworkEndpointGroupsConnection::ListNetworkEndpoints");
  internal::OTelScope scope(span);
  auto sr = child_->ListNetworkEndpoints(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::cpp::compute::v1::NetworkEndpointWithHealthStatus>(
      std::move(span), std::move(sr));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<compute_global_network_endpoint_groups_v1::
                    GlobalNetworkEndpointGroupsConnection>
MakeGlobalNetworkEndpointGroupsTracingConnection(
    std::shared_ptr<compute_global_network_endpoint_groups_v1::
                        GlobalNetworkEndpointGroupsConnection>
        conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<GlobalNetworkEndpointGroupsTracingConnection>(
        std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_global_network_endpoint_groups_v1_internal
}  // namespace cloud
}  // namespace google
