// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/health_checks/v1/health_checks.proto

#include "google/cloud/compute/health_checks/v1/health_checks_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_health_checks_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

HealthChecksConnectionIdempotencyPolicy::
    ~HealthChecksConnectionIdempotencyPolicy() = default;

std::unique_ptr<HealthChecksConnectionIdempotencyPolicy>
HealthChecksConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<HealthChecksConnectionIdempotencyPolicy>(*this);
}

Idempotency HealthChecksConnectionIdempotencyPolicy::AggregatedListHealthChecks(
    google::cloud::cpp::compute::health_checks::v1::
        AggregatedListHealthChecksRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency HealthChecksConnectionIdempotencyPolicy::DeleteHealthCheck(
    google::cloud::cpp::compute::health_checks::v1::
        DeleteHealthCheckRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency HealthChecksConnectionIdempotencyPolicy::GetHealthCheck(
    google::cloud::cpp::compute::health_checks::v1::
        GetHealthCheckRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency HealthChecksConnectionIdempotencyPolicy::InsertHealthCheck(
    google::cloud::cpp::compute::health_checks::v1::
        InsertHealthCheckRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency HealthChecksConnectionIdempotencyPolicy::ListHealthChecks(
    google::cloud::cpp::compute::health_checks::v1::
        ListHealthChecksRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency HealthChecksConnectionIdempotencyPolicy::PatchHealthCheck(
    google::cloud::cpp::compute::health_checks::v1::
        PatchHealthCheckRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency HealthChecksConnectionIdempotencyPolicy::UpdateHealthCheck(
    google::cloud::cpp::compute::health_checks::v1::
        UpdateHealthCheckRequest const&) {
  return Idempotency::kIdempotent;
}

std::unique_ptr<HealthChecksConnectionIdempotencyPolicy>
MakeDefaultHealthChecksConnectionIdempotencyPolicy() {
  return std::make_unique<HealthChecksConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_health_checks_v1
}  // namespace cloud
}  // namespace google
