// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/instance_group_manager_resize_requests/v1/instance_group_manager_resize_requests.proto

#include "google/cloud/compute/instance_group_manager_resize_requests/v1/instance_group_manager_resize_requests_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_instance_group_manager_resize_requests_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy::
    ~InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy() = default;

std::unique_ptr<InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy>
InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<
      InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy>(*this);
}

Idempotency
InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy::Cancel(
    google::cloud::cpp::compute::instance_group_manager_resize_requests::v1::
        CancelRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy::
    DeleteInstanceGroupManagerResizeRequest(
        google::cloud::cpp::compute::instance_group_manager_resize_requests::
            v1::DeleteInstanceGroupManagerResizeRequestRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy::
    GetInstanceGroupManagerResizeRequest(
        google::cloud::cpp::compute::instance_group_manager_resize_requests::
            v1::GetInstanceGroupManagerResizeRequestRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy::
    InsertInstanceGroupManagerResizeRequest(
        google::cloud::cpp::compute::instance_group_manager_resize_requests::
            v1::InsertInstanceGroupManagerResizeRequestRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy::
    ListInstanceGroupManagerResizeRequests(
        google::cloud::cpp::compute::instance_group_manager_resize_requests::
            v1::ListInstanceGroupManagerResizeRequestsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

std::unique_ptr<InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy>
MakeDefaultInstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy() {
  return std::make_unique<
      InstanceGroupManagerResizeRequestsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_instance_group_manager_resize_requests_v1
}  // namespace cloud
}  // namespace google
