// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/instance_templates/v1/instance_templates.proto

#include "google/cloud/compute/instance_templates/v1/instance_templates_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_instance_templates_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

InstanceTemplatesConnectionIdempotencyPolicy::
    ~InstanceTemplatesConnectionIdempotencyPolicy() = default;

std::unique_ptr<InstanceTemplatesConnectionIdempotencyPolicy>
InstanceTemplatesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<InstanceTemplatesConnectionIdempotencyPolicy>(*this);
}

Idempotency
InstanceTemplatesConnectionIdempotencyPolicy::AggregatedListInstanceTemplates(
    google::cloud::cpp::compute::instance_templates::v1::
        AggregatedListInstanceTemplatesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
InstanceTemplatesConnectionIdempotencyPolicy::DeleteInstanceTemplate(
    google::cloud::cpp::compute::instance_templates::v1::
        DeleteInstanceTemplateRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstanceTemplatesConnectionIdempotencyPolicy::GetInstanceTemplate(
    google::cloud::cpp::compute::instance_templates::v1::
        GetInstanceTemplateRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency InstanceTemplatesConnectionIdempotencyPolicy::GetIamPolicy(
    google::cloud::cpp::compute::instance_templates::v1::
        GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
InstanceTemplatesConnectionIdempotencyPolicy::InsertInstanceTemplate(
    google::cloud::cpp::compute::instance_templates::v1::
        InsertInstanceTemplateRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstanceTemplatesConnectionIdempotencyPolicy::ListInstanceTemplates(
    google::cloud::cpp::compute::instance_templates::v1::
        ListInstanceTemplatesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency InstanceTemplatesConnectionIdempotencyPolicy::SetIamPolicy(
    google::cloud::cpp::compute::instance_templates::v1::
        SetIamPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstanceTemplatesConnectionIdempotencyPolicy::TestIamPermissions(
    google::cloud::cpp::compute::instance_templates::v1::
        TestIamPermissionsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<InstanceTemplatesConnectionIdempotencyPolicy>
MakeDefaultInstanceTemplatesConnectionIdempotencyPolicy() {
  return std::make_unique<InstanceTemplatesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_instance_templates_v1
}  // namespace cloud
}  // namespace google
