// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/instant_snapshots/v1/instant_snapshots.proto

#include "google/cloud/compute/instant_snapshots/v1/instant_snapshots_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_instant_snapshots_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

InstantSnapshotsConnectionIdempotencyPolicy::
    ~InstantSnapshotsConnectionIdempotencyPolicy() = default;

std::unique_ptr<InstantSnapshotsConnectionIdempotencyPolicy>
InstantSnapshotsConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<InstantSnapshotsConnectionIdempotencyPolicy>(*this);
}

Idempotency
InstantSnapshotsConnectionIdempotencyPolicy::AggregatedListInstantSnapshots(
    google::cloud::cpp::compute::instant_snapshots::v1::
        AggregatedListInstantSnapshotsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency InstantSnapshotsConnectionIdempotencyPolicy::DeleteInstantSnapshot(
    google::cloud::cpp::compute::instant_snapshots::v1::
        DeleteInstantSnapshotRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstantSnapshotsConnectionIdempotencyPolicy::GetInstantSnapshot(
    google::cloud::cpp::compute::instant_snapshots::v1::
        GetInstantSnapshotRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency InstantSnapshotsConnectionIdempotencyPolicy::GetIamPolicy(
    google::cloud::cpp::compute::instant_snapshots::v1::
        GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency InstantSnapshotsConnectionIdempotencyPolicy::InsertInstantSnapshot(
    google::cloud::cpp::compute::instant_snapshots::v1::
        InsertInstantSnapshotRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstantSnapshotsConnectionIdempotencyPolicy::ListInstantSnapshots(
    google::cloud::cpp::compute::instant_snapshots::v1::
        ListInstantSnapshotsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency InstantSnapshotsConnectionIdempotencyPolicy::SetIamPolicy(
    google::cloud::cpp::compute::instant_snapshots::v1::
        SetIamPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstantSnapshotsConnectionIdempotencyPolicy::SetLabels(
    google::cloud::cpp::compute::instant_snapshots::v1::
        SetLabelsRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency InstantSnapshotsConnectionIdempotencyPolicy::TestIamPermissions(
    google::cloud::cpp::compute::instant_snapshots::v1::
        TestIamPermissionsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<InstantSnapshotsConnectionIdempotencyPolicy>
MakeDefaultInstantSnapshotsConnectionIdempotencyPolicy() {
  return std::make_unique<InstantSnapshotsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_instant_snapshots_v1
}  // namespace cloud
}  // namespace google
