// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/interconnect_remote_locations/v1/interconnect_remote_locations.proto

#include "google/cloud/compute/interconnect_remote_locations/v1/internal/interconnect_remote_locations_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_interconnect_remote_locations_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

InterconnectRemoteLocationsTracingConnection::
    InterconnectRemoteLocationsTracingConnection(
        std::shared_ptr<compute_interconnect_remote_locations_v1::
                            InterconnectRemoteLocationsConnection>
            child)
    : child_(std::move(child)) {}

StatusOr<google::cloud::cpp::compute::v1::InterconnectRemoteLocation>
InterconnectRemoteLocationsTracingConnection::GetInterconnectRemoteLocation(
    google::cloud::cpp::compute::interconnect_remote_locations::v1::
        GetInterconnectRemoteLocationRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_interconnect_remote_locations_v1::"
      "InterconnectRemoteLocationsConnection::GetInterconnectRemoteLocation");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span,
                           child_->GetInterconnectRemoteLocation(request));
}

StreamRange<google::cloud::cpp::compute::v1::InterconnectRemoteLocation>
InterconnectRemoteLocationsTracingConnection::ListInterconnectRemoteLocations(
    google::cloud::cpp::compute::interconnect_remote_locations::v1::
        ListInterconnectRemoteLocationsRequest request) {
  auto span = internal::MakeSpan(
      "compute_interconnect_remote_locations_v1::"
      "InterconnectRemoteLocationsConnection::ListInterconnectRemoteLocations");
  internal::OTelScope scope(span);
  auto sr = child_->ListInterconnectRemoteLocations(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::cpp::compute::v1::InterconnectRemoteLocation>(
      std::move(span), std::move(sr));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<compute_interconnect_remote_locations_v1::
                    InterconnectRemoteLocationsConnection>
MakeInterconnectRemoteLocationsTracingConnection(
    std::shared_ptr<compute_interconnect_remote_locations_v1::
                        InterconnectRemoteLocationsConnection>
        conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<InterconnectRemoteLocationsTracingConnection>(
        std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_interconnect_remote_locations_v1_internal
}  // namespace cloud
}  // namespace google
