// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/licenses/v1/licenses.proto

#include "google/cloud/compute/licenses/v1/licenses_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_licenses_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

LicensesConnectionIdempotencyPolicy::~LicensesConnectionIdempotencyPolicy() =
    default;

std::unique_ptr<LicensesConnectionIdempotencyPolicy>
LicensesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<LicensesConnectionIdempotencyPolicy>(*this);
}

Idempotency LicensesConnectionIdempotencyPolicy::DeleteLicense(
    google::cloud::cpp::compute::licenses::v1::DeleteLicenseRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency LicensesConnectionIdempotencyPolicy::GetLicense(
    google::cloud::cpp::compute::licenses::v1::GetLicenseRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency LicensesConnectionIdempotencyPolicy::GetIamPolicy(
    google::cloud::cpp::compute::licenses::v1::GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency LicensesConnectionIdempotencyPolicy::InsertLicense(
    google::cloud::cpp::compute::licenses::v1::InsertLicenseRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency LicensesConnectionIdempotencyPolicy::ListLicenses(
    google::cloud::cpp::compute::licenses::v1::ListLicensesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency LicensesConnectionIdempotencyPolicy::SetIamPolicy(
    google::cloud::cpp::compute::licenses::v1::SetIamPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency LicensesConnectionIdempotencyPolicy::TestIamPermissions(
    google::cloud::cpp::compute::licenses::v1::
        TestIamPermissionsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<LicensesConnectionIdempotencyPolicy>
MakeDefaultLicensesConnectionIdempotencyPolicy() {
  return std::make_unique<LicensesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_licenses_v1
}  // namespace cloud
}  // namespace google
