// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/machine_types/v1/machine_types.proto

#include "google/cloud/compute/machine_types/v1/internal/machine_types_rest_metadata_decorator.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/internal/rest_set_metadata.h"
#include "google/cloud/status_or.h"
#include "absl/strings/str_format.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_machine_types_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

MachineTypesRestMetadata::MachineTypesRestMetadata(
    std::shared_ptr<MachineTypesRestStub> child, std::string api_client_header)
    : child_(std::move(child)),
      api_client_header_(
          api_client_header.empty()
              ? google::cloud::internal::GeneratedLibClientHeader()
              : std::move(api_client_header)) {}

StatusOr<google::cloud::cpp::compute::v1::MachineTypeAggregatedList>
MachineTypesRestMetadata::AggregatedListMachineTypes(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::machine_types::v1::
        AggregatedListMachineTypesRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->AggregatedListMachineTypes(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::MachineType>
MachineTypesRestMetadata::GetMachineType(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::machine_types::v1::GetMachineTypeRequest const&
        request) {
  SetMetadata(rest_context, options);
  return child_->GetMachineType(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::MachineTypeList>
MachineTypesRestMetadata::ListMachineTypes(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::machine_types::v1::
        ListMachineTypesRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->ListMachineTypes(rest_context, options, request);
}

void MachineTypesRestMetadata::SetMetadata(
    rest_internal::RestContext& rest_context, Options const& options,
    std::vector<std::string> const& params) {
  google::cloud::rest_internal::SetMetadata(rest_context, options, params,
                                            api_client_header_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_machine_types_v1_internal
}  // namespace cloud
}  // namespace google
