// Copyright 2025 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/network_profiles/v1/network_profiles.proto

#include "google/cloud/compute/network_profiles/v1/network_profiles_client.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_network_profiles_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

NetworkProfilesClient::NetworkProfilesClient(
    std::shared_ptr<NetworkProfilesConnection> connection, Options opts)
    : connection_(std::move(connection)),
      options_(
          internal::MergeOptions(std::move(opts), connection_->options())) {}
NetworkProfilesClient::~NetworkProfilesClient() = default;

StatusOr<google::cloud::cpp::compute::v1::NetworkProfile>
NetworkProfilesClient::GetNetworkProfile(std::string const& project,
                                         std::string const& network_profile,
                                         Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::network_profiles::v1::GetNetworkProfileRequest
      request;
  request.set_project(project);
  request.set_network_profile(network_profile);
  return connection_->GetNetworkProfile(request);
}

StatusOr<google::cloud::cpp::compute::v1::NetworkProfile>
NetworkProfilesClient::GetNetworkProfile(
    google::cloud::cpp::compute::network_profiles::v1::
        GetNetworkProfileRequest const& request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->GetNetworkProfile(request);
}

StreamRange<google::cloud::cpp::compute::v1::NetworkProfile>
NetworkProfilesClient::ListNetworkProfiles(std::string const& project,
                                           Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::network_profiles::v1::ListNetworkProfilesRequest
      request;
  request.set_project(project);
  return connection_->ListNetworkProfiles(request);
}

StreamRange<google::cloud::cpp::compute::v1::NetworkProfile>
NetworkProfilesClient::ListNetworkProfiles(
    google::cloud::cpp::compute::network_profiles::v1::
        ListNetworkProfilesRequest request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->ListNetworkProfiles(std::move(request));
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_network_profiles_v1
}  // namespace cloud
}  // namespace google
