// Copyright 2025 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/network_profiles/v1/network_profiles.proto

#include "google/cloud/compute/network_profiles/v1/network_profiles_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_network_profiles_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

NetworkProfilesConnectionIdempotencyPolicy::
    ~NetworkProfilesConnectionIdempotencyPolicy() = default;

std::unique_ptr<NetworkProfilesConnectionIdempotencyPolicy>
NetworkProfilesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<NetworkProfilesConnectionIdempotencyPolicy>(*this);
}

Idempotency NetworkProfilesConnectionIdempotencyPolicy::GetNetworkProfile(
    google::cloud::cpp::compute::network_profiles::v1::
        GetNetworkProfileRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency NetworkProfilesConnectionIdempotencyPolicy::ListNetworkProfiles(
    google::cloud::cpp::compute::network_profiles::v1::
        ListNetworkProfilesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

std::unique_ptr<NetworkProfilesConnectionIdempotencyPolicy>
MakeDefaultNetworkProfilesConnectionIdempotencyPolicy() {
  return std::make_unique<NetworkProfilesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_network_profiles_v1
}  // namespace cloud
}  // namespace google
