// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/packet_mirrorings/v1/packet_mirrorings.proto

#include "google/cloud/compute/packet_mirrorings/v1/packet_mirrorings_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_packet_mirrorings_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

PacketMirroringsConnectionIdempotencyPolicy::
    ~PacketMirroringsConnectionIdempotencyPolicy() = default;

std::unique_ptr<PacketMirroringsConnectionIdempotencyPolicy>
PacketMirroringsConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<PacketMirroringsConnectionIdempotencyPolicy>(*this);
}

Idempotency
PacketMirroringsConnectionIdempotencyPolicy::AggregatedListPacketMirrorings(
    google::cloud::cpp::compute::packet_mirrorings::v1::
        AggregatedListPacketMirroringsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency PacketMirroringsConnectionIdempotencyPolicy::DeletePacketMirroring(
    google::cloud::cpp::compute::packet_mirrorings::v1::
        DeletePacketMirroringRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PacketMirroringsConnectionIdempotencyPolicy::GetPacketMirroring(
    google::cloud::cpp::compute::packet_mirrorings::v1::
        GetPacketMirroringRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency PacketMirroringsConnectionIdempotencyPolicy::InsertPacketMirroring(
    google::cloud::cpp::compute::packet_mirrorings::v1::
        InsertPacketMirroringRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PacketMirroringsConnectionIdempotencyPolicy::ListPacketMirrorings(
    google::cloud::cpp::compute::packet_mirrorings::v1::
        ListPacketMirroringsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency PacketMirroringsConnectionIdempotencyPolicy::PatchPacketMirroring(
    google::cloud::cpp::compute::packet_mirrorings::v1::
        PatchPacketMirroringRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PacketMirroringsConnectionIdempotencyPolicy::TestIamPermissions(
    google::cloud::cpp::compute::packet_mirrorings::v1::
        TestIamPermissionsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<PacketMirroringsConnectionIdempotencyPolicy>
MakeDefaultPacketMirroringsConnectionIdempotencyPolicy() {
  return std::make_unique<PacketMirroringsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_packet_mirrorings_v1
}  // namespace cloud
}  // namespace google
