// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/public_advertised_prefixes/v1/public_advertised_prefixes.proto

#include "google/cloud/compute/public_advertised_prefixes/v1/internal/public_advertised_prefixes_rest_metadata_decorator.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/internal/rest_set_metadata.h"
#include "google/cloud/status_or.h"
#include "absl/strings/str_format.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_public_advertised_prefixes_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

PublicAdvertisedPrefixesRestMetadata::PublicAdvertisedPrefixesRestMetadata(
    std::shared_ptr<PublicAdvertisedPrefixesRestStub> child,
    std::string api_client_header)
    : child_(std::move(child)),
      api_client_header_(
          api_client_header.empty()
              ? google::cloud::internal::GeneratedLibClientHeader()
              : std::move(api_client_header)) {}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicAdvertisedPrefixesRestMetadata::AsyncAnnounce(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        AnnounceRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncAnnounce(cq, std::move(rest_context), std::move(options),
                               request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicAdvertisedPrefixesRestMetadata::Announce(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        AnnounceRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->Announce(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicAdvertisedPrefixesRestMetadata::AsyncDeletePublicAdvertisedPrefix(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        DeletePublicAdvertisedPrefixRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncDeletePublicAdvertisedPrefix(cq, std::move(rest_context),
                                                   std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicAdvertisedPrefixesRestMetadata::DeletePublicAdvertisedPrefix(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        DeletePublicAdvertisedPrefixRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->DeletePublicAdvertisedPrefix(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::PublicAdvertisedPrefix>
PublicAdvertisedPrefixesRestMetadata::GetPublicAdvertisedPrefix(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        GetPublicAdvertisedPrefixRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->GetPublicAdvertisedPrefix(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicAdvertisedPrefixesRestMetadata::AsyncInsertPublicAdvertisedPrefix(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        InsertPublicAdvertisedPrefixRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncInsertPublicAdvertisedPrefix(cq, std::move(rest_context),
                                                   std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicAdvertisedPrefixesRestMetadata::InsertPublicAdvertisedPrefix(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        InsertPublicAdvertisedPrefixRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->InsertPublicAdvertisedPrefix(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::PublicAdvertisedPrefixList>
PublicAdvertisedPrefixesRestMetadata::ListPublicAdvertisedPrefixes(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        ListPublicAdvertisedPrefixesRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->ListPublicAdvertisedPrefixes(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicAdvertisedPrefixesRestMetadata::AsyncPatchPublicAdvertisedPrefix(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        PatchPublicAdvertisedPrefixRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncPatchPublicAdvertisedPrefix(cq, std::move(rest_context),
                                                  std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicAdvertisedPrefixesRestMetadata::PatchPublicAdvertisedPrefix(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        PatchPublicAdvertisedPrefixRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->PatchPublicAdvertisedPrefix(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicAdvertisedPrefixesRestMetadata::AsyncWithdraw(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        WithdrawRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncWithdraw(cq, std::move(rest_context), std::move(options),
                               request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicAdvertisedPrefixesRestMetadata::Withdraw(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_advertised_prefixes::v1::
        WithdrawRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->Withdraw(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicAdvertisedPrefixesRestMetadata::AsyncGetOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::global_operations::v1::
        GetOperationRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncGetOperation(cq, std::move(rest_context),
                                   std::move(options), request);
}

future<Status> PublicAdvertisedPrefixesRestMetadata::AsyncCancelOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::global_operations::v1::
        DeleteOperationRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncCancelOperation(cq, std::move(rest_context),
                                      std::move(options), request);
}

void PublicAdvertisedPrefixesRestMetadata::SetMetadata(
    rest_internal::RestContext& rest_context, Options const& options,
    std::vector<std::string> const& params) {
  google::cloud::rest_internal::SetMetadata(rest_context, options, params,
                                            api_client_header_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_public_advertised_prefixes_v1_internal
}  // namespace cloud
}  // namespace google
