// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/public_delegated_prefixes/v1/public_delegated_prefixes.proto

#include "google/cloud/compute/public_delegated_prefixes/v1/internal/public_delegated_prefixes_rest_metadata_decorator.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/internal/rest_set_metadata.h"
#include "google/cloud/status_or.h"
#include "absl/strings/str_format.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_public_delegated_prefixes_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

PublicDelegatedPrefixesRestMetadata::PublicDelegatedPrefixesRestMetadata(
    std::shared_ptr<PublicDelegatedPrefixesRestStub> child,
    std::string api_client_header)
    : child_(std::move(child)),
      api_client_header_(
          api_client_header.empty()
              ? google::cloud::internal::GeneratedLibClientHeader()
              : std::move(api_client_header)) {}

StatusOr<google::cloud::cpp::compute::v1::PublicDelegatedPrefixAggregatedList>
PublicDelegatedPrefixesRestMetadata::AggregatedListPublicDelegatedPrefixes(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        AggregatedListPublicDelegatedPrefixesRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->AggregatedListPublicDelegatedPrefixes(rest_context, options,
                                                       request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicDelegatedPrefixesRestMetadata::AsyncAnnounce(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        AnnounceRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncAnnounce(cq, std::move(rest_context), std::move(options),
                               request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicDelegatedPrefixesRestMetadata::Announce(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        AnnounceRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->Announce(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicDelegatedPrefixesRestMetadata::AsyncDeletePublicDelegatedPrefix(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        DeletePublicDelegatedPrefixRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncDeletePublicDelegatedPrefix(cq, std::move(rest_context),
                                                  std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicDelegatedPrefixesRestMetadata::DeletePublicDelegatedPrefix(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        DeletePublicDelegatedPrefixRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->DeletePublicDelegatedPrefix(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::PublicDelegatedPrefix>
PublicDelegatedPrefixesRestMetadata::GetPublicDelegatedPrefix(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        GetPublicDelegatedPrefixRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->GetPublicDelegatedPrefix(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicDelegatedPrefixesRestMetadata::AsyncInsertPublicDelegatedPrefix(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        InsertPublicDelegatedPrefixRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncInsertPublicDelegatedPrefix(cq, std::move(rest_context),
                                                  std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicDelegatedPrefixesRestMetadata::InsertPublicDelegatedPrefix(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        InsertPublicDelegatedPrefixRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->InsertPublicDelegatedPrefix(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::PublicDelegatedPrefixList>
PublicDelegatedPrefixesRestMetadata::ListPublicDelegatedPrefixes(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        ListPublicDelegatedPrefixesRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->ListPublicDelegatedPrefixes(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicDelegatedPrefixesRestMetadata::AsyncPatchPublicDelegatedPrefix(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        PatchPublicDelegatedPrefixRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncPatchPublicDelegatedPrefix(cq, std::move(rest_context),
                                                 std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicDelegatedPrefixesRestMetadata::PatchPublicDelegatedPrefix(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        PatchPublicDelegatedPrefixRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->PatchPublicDelegatedPrefix(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicDelegatedPrefixesRestMetadata::AsyncWithdraw(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        WithdrawRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncWithdraw(cq, std::move(rest_context), std::move(options),
                               request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
PublicDelegatedPrefixesRestMetadata::Withdraw(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        WithdrawRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->Withdraw(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicDelegatedPrefixesRestMetadata::AsyncGetOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::region_operations::v1::
        GetOperationRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncGetOperation(cq, std::move(rest_context),
                                   std::move(options), request);
}

future<Status> PublicDelegatedPrefixesRestMetadata::AsyncCancelOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::region_operations::v1::
        DeleteOperationRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncCancelOperation(cq, std::move(rest_context),
                                      std::move(options), request);
}

void PublicDelegatedPrefixesRestMetadata::SetMetadata(
    rest_internal::RestContext& rest_context, Options const& options,
    std::vector<std::string> const& params) {
  google::cloud::rest_internal::SetMetadata(rest_context, options, params,
                                            api_client_header_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_public_delegated_prefixes_v1_internal
}  // namespace cloud
}  // namespace google
