// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/region_autoscalers/v1/region_autoscalers.proto

#include "google/cloud/compute/region_autoscalers/v1/region_autoscalers_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_region_autoscalers_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

RegionAutoscalersConnectionIdempotencyPolicy::
    ~RegionAutoscalersConnectionIdempotencyPolicy() = default;

std::unique_ptr<RegionAutoscalersConnectionIdempotencyPolicy>
RegionAutoscalersConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<RegionAutoscalersConnectionIdempotencyPolicy>(*this);
}

Idempotency RegionAutoscalersConnectionIdempotencyPolicy::DeleteAutoscaler(
    google::cloud::cpp::compute::region_autoscalers::v1::
        DeleteAutoscalerRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RegionAutoscalersConnectionIdempotencyPolicy::GetAutoscaler(
    google::cloud::cpp::compute::region_autoscalers::v1::
        GetAutoscalerRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency RegionAutoscalersConnectionIdempotencyPolicy::InsertAutoscaler(
    google::cloud::cpp::compute::region_autoscalers::v1::
        InsertAutoscalerRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RegionAutoscalersConnectionIdempotencyPolicy::ListRegionAutoscalers(
    google::cloud::cpp::compute::region_autoscalers::v1::
        ListRegionAutoscalersRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency RegionAutoscalersConnectionIdempotencyPolicy::PatchAutoscaler(
    google::cloud::cpp::compute::region_autoscalers::v1::
        PatchAutoscalerRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RegionAutoscalersConnectionIdempotencyPolicy::UpdateAutoscaler(
    google::cloud::cpp::compute::region_autoscalers::v1::
        UpdateAutoscalerRequest const&) {
  return Idempotency::kIdempotent;
}

std::unique_ptr<RegionAutoscalersConnectionIdempotencyPolicy>
MakeDefaultRegionAutoscalersConnectionIdempotencyPolicy() {
  return std::make_unique<RegionAutoscalersConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_autoscalers_v1
}  // namespace cloud
}  // namespace google
