// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/region_notification_endpoints/v1/region_notification_endpoints.proto

#include "google/cloud/compute/region_notification_endpoints/v1/region_notification_endpoints_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_region_notification_endpoints_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

RegionNotificationEndpointsConnectionIdempotencyPolicy::
    ~RegionNotificationEndpointsConnectionIdempotencyPolicy() = default;

std::unique_ptr<RegionNotificationEndpointsConnectionIdempotencyPolicy>
RegionNotificationEndpointsConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<
      RegionNotificationEndpointsConnectionIdempotencyPolicy>(*this);
}

Idempotency RegionNotificationEndpointsConnectionIdempotencyPolicy::
    DeleteNotificationEndpoint(
        google::cloud::cpp::compute::region_notification_endpoints::v1::
            DeleteNotificationEndpointRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
RegionNotificationEndpointsConnectionIdempotencyPolicy::GetNotificationEndpoint(
    google::cloud::cpp::compute::region_notification_endpoints::v1::
        GetNotificationEndpointRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency RegionNotificationEndpointsConnectionIdempotencyPolicy::
    InsertNotificationEndpoint(
        google::cloud::cpp::compute::region_notification_endpoints::v1::
            InsertNotificationEndpointRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RegionNotificationEndpointsConnectionIdempotencyPolicy::
    ListRegionNotificationEndpoints(
        google::cloud::cpp::compute::region_notification_endpoints::v1::
            ListRegionNotificationEndpointsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

std::unique_ptr<RegionNotificationEndpointsConnectionIdempotencyPolicy>
MakeDefaultRegionNotificationEndpointsConnectionIdempotencyPolicy() {
  return std::make_unique<
      RegionNotificationEndpointsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_notification_endpoints_v1
}  // namespace cloud
}  // namespace google
