// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/region_target_tcp_proxies/v1/region_target_tcp_proxies.proto

#include "google/cloud/compute/region_target_tcp_proxies/v1/internal/region_target_tcp_proxies_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_region_target_tcp_proxies_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

RegionTargetTcpProxiesTracingConnection::
    RegionTargetTcpProxiesTracingConnection(
        std::shared_ptr<compute_region_target_tcp_proxies_v1::
                            RegionTargetTcpProxiesConnection>
            child)
    : child_(std::move(child)) {}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RegionTargetTcpProxiesTracingConnection::DeleteTargetTcpProxy(
    google::cloud::cpp::compute::region_target_tcp_proxies::v1::
        DeleteTargetTcpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection::"
      "DeleteTargetTcpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteTargetTcpProxy(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
RegionTargetTcpProxiesTracingConnection::DeleteTargetTcpProxy(
    NoAwaitTag, google::cloud::cpp::compute::region_target_tcp_proxies::v1::
                    DeleteTargetTcpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection::"
      "DeleteTargetTcpProxy");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->DeleteTargetTcpProxy(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RegionTargetTcpProxiesTracingConnection::DeleteTargetTcpProxy(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection::"
      "DeleteTargetTcpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteTargetTcpProxy(operation));
}

StatusOr<google::cloud::cpp::compute::v1::TargetTcpProxy>
RegionTargetTcpProxiesTracingConnection::GetTargetTcpProxy(
    google::cloud::cpp::compute::region_target_tcp_proxies::v1::
        GetTargetTcpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection::"
      "GetTargetTcpProxy");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetTargetTcpProxy(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RegionTargetTcpProxiesTracingConnection::InsertTargetTcpProxy(
    google::cloud::cpp::compute::region_target_tcp_proxies::v1::
        InsertTargetTcpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection::"
      "InsertTargetTcpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertTargetTcpProxy(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
RegionTargetTcpProxiesTracingConnection::InsertTargetTcpProxy(
    NoAwaitTag, google::cloud::cpp::compute::region_target_tcp_proxies::v1::
                    InsertTargetTcpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection::"
      "InsertTargetTcpProxy");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->InsertTargetTcpProxy(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RegionTargetTcpProxiesTracingConnection::InsertTargetTcpProxy(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection::"
      "InsertTargetTcpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertTargetTcpProxy(operation));
}

StreamRange<google::cloud::cpp::compute::v1::TargetTcpProxy>
RegionTargetTcpProxiesTracingConnection::ListRegionTargetTcpProxies(
    google::cloud::cpp::compute::region_target_tcp_proxies::v1::
        ListRegionTargetTcpProxiesRequest request) {
  auto span = internal::MakeSpan(
      "compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection::"
      "ListRegionTargetTcpProxies");
  internal::OTelScope scope(span);
  auto sr = child_->ListRegionTargetTcpProxies(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::cpp::compute::v1::TargetTcpProxy>(std::move(span),
                                                       std::move(sr));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<
    compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection>
MakeRegionTargetTcpProxiesTracingConnection(
    std::shared_ptr<
        compute_region_target_tcp_proxies_v1::RegionTargetTcpProxiesConnection>
        conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<RegionTargetTcpProxiesTracingConnection>(
        std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_target_tcp_proxies_v1_internal
}  // namespace cloud
}  // namespace google
