// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/region_target_tcp_proxies/v1/region_target_tcp_proxies.proto

#include "google/cloud/compute/region_target_tcp_proxies/v1/region_target_tcp_proxies_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_region_target_tcp_proxies_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

RegionTargetTcpProxiesConnectionIdempotencyPolicy::
    ~RegionTargetTcpProxiesConnectionIdempotencyPolicy() = default;

std::unique_ptr<RegionTargetTcpProxiesConnectionIdempotencyPolicy>
RegionTargetTcpProxiesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<RegionTargetTcpProxiesConnectionIdempotencyPolicy>(
      *this);
}

Idempotency
RegionTargetTcpProxiesConnectionIdempotencyPolicy::DeleteTargetTcpProxy(
    google::cloud::cpp::compute::region_target_tcp_proxies::v1::
        DeleteTargetTcpProxyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
RegionTargetTcpProxiesConnectionIdempotencyPolicy::GetTargetTcpProxy(
    google::cloud::cpp::compute::region_target_tcp_proxies::v1::
        GetTargetTcpProxyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
RegionTargetTcpProxiesConnectionIdempotencyPolicy::InsertTargetTcpProxy(
    google::cloud::cpp::compute::region_target_tcp_proxies::v1::
        InsertTargetTcpProxyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
RegionTargetTcpProxiesConnectionIdempotencyPolicy::ListRegionTargetTcpProxies(
    google::cloud::cpp::compute::region_target_tcp_proxies::v1::
        ListRegionTargetTcpProxiesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

std::unique_ptr<RegionTargetTcpProxiesConnectionIdempotencyPolicy>
MakeDefaultRegionTargetTcpProxiesConnectionIdempotencyPolicy() {
  return std::make_unique<RegionTargetTcpProxiesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_target_tcp_proxies_v1
}  // namespace cloud
}  // namespace google
