// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/region_url_maps/v1/region_url_maps.proto

#include "google/cloud/compute/region_url_maps/v1/internal/region_url_maps_rest_metadata_decorator.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/internal/rest_set_metadata.h"
#include "google/cloud/status_or.h"
#include "absl/strings/str_format.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_region_url_maps_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

RegionUrlMapsRestMetadata::RegionUrlMapsRestMetadata(
    std::shared_ptr<RegionUrlMapsRestStub> child, std::string api_client_header)
    : child_(std::move(child)),
      api_client_header_(
          api_client_header.empty()
              ? google::cloud::internal::GeneratedLibClientHeader()
              : std::move(api_client_header)) {}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RegionUrlMapsRestMetadata::AsyncDeleteUrlMap(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::region_url_maps::v1::DeleteUrlMapRequest const&
        request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncDeleteUrlMap(cq, std::move(rest_context),
                                   std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
RegionUrlMapsRestMetadata::DeleteUrlMap(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::region_url_maps::v1::DeleteUrlMapRequest const&
        request) {
  SetMetadata(rest_context, options);
  return child_->DeleteUrlMap(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::UrlMap>
RegionUrlMapsRestMetadata::GetUrlMap(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::region_url_maps::v1::GetUrlMapRequest const&
        request) {
  SetMetadata(rest_context, options);
  return child_->GetUrlMap(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RegionUrlMapsRestMetadata::AsyncInsertUrlMap(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::region_url_maps::v1::InsertUrlMapRequest const&
        request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncInsertUrlMap(cq, std::move(rest_context),
                                   std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
RegionUrlMapsRestMetadata::InsertUrlMap(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::region_url_maps::v1::InsertUrlMapRequest const&
        request) {
  SetMetadata(rest_context, options);
  return child_->InsertUrlMap(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::UrlMapList>
RegionUrlMapsRestMetadata::ListRegionUrlMaps(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::region_url_maps::v1::
        ListRegionUrlMapsRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->ListRegionUrlMaps(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RegionUrlMapsRestMetadata::AsyncPatchUrlMap(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::region_url_maps::v1::PatchUrlMapRequest const&
        request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncPatchUrlMap(cq, std::move(rest_context),
                                  std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
RegionUrlMapsRestMetadata::PatchUrlMap(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::region_url_maps::v1::PatchUrlMapRequest const&
        request) {
  SetMetadata(rest_context, options);
  return child_->PatchUrlMap(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RegionUrlMapsRestMetadata::AsyncUpdateUrlMap(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::region_url_maps::v1::UpdateUrlMapRequest const&
        request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncUpdateUrlMap(cq, std::move(rest_context),
                                   std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
RegionUrlMapsRestMetadata::UpdateUrlMap(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::region_url_maps::v1::UpdateUrlMapRequest const&
        request) {
  SetMetadata(rest_context, options);
  return child_->UpdateUrlMap(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::UrlMapsValidateResponse>
RegionUrlMapsRestMetadata::Validate(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::region_url_maps::v1::ValidateRequest const&
        request) {
  SetMetadata(rest_context, options);
  return child_->Validate(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RegionUrlMapsRestMetadata::AsyncGetOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::region_operations::v1::
        GetOperationRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncGetOperation(cq, std::move(rest_context),
                                   std::move(options), request);
}

future<Status> RegionUrlMapsRestMetadata::AsyncCancelOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::region_operations::v1::
        DeleteOperationRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncCancelOperation(cq, std::move(rest_context),
                                      std::move(options), request);
}

void RegionUrlMapsRestMetadata::SetMetadata(
    rest_internal::RestContext& rest_context, Options const& options,
    std::vector<std::string> const& params) {
  google::cloud::rest_internal::SetMetadata(rest_context, options, params,
                                            api_client_header_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_url_maps_v1_internal
}  // namespace cloud
}  // namespace google
