// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/resource_policies/v1/resource_policies.proto

#include "google/cloud/compute/resource_policies/v1/resource_policies_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_resource_policies_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ResourcePoliciesConnectionIdempotencyPolicy::
    ~ResourcePoliciesConnectionIdempotencyPolicy() = default;

std::unique_ptr<ResourcePoliciesConnectionIdempotencyPolicy>
ResourcePoliciesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<ResourcePoliciesConnectionIdempotencyPolicy>(*this);
}

Idempotency
ResourcePoliciesConnectionIdempotencyPolicy::AggregatedListResourcePolicies(
    google::cloud::cpp::compute::resource_policies::v1::
        AggregatedListResourcePoliciesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency ResourcePoliciesConnectionIdempotencyPolicy::DeleteResourcePolicy(
    google::cloud::cpp::compute::resource_policies::v1::
        DeleteResourcePolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ResourcePoliciesConnectionIdempotencyPolicy::GetResourcePolicy(
    google::cloud::cpp::compute::resource_policies::v1::
        GetResourcePolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency ResourcePoliciesConnectionIdempotencyPolicy::GetIamPolicy(
    google::cloud::cpp::compute::resource_policies::v1::
        GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency ResourcePoliciesConnectionIdempotencyPolicy::InsertResourcePolicy(
    google::cloud::cpp::compute::resource_policies::v1::
        InsertResourcePolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ResourcePoliciesConnectionIdempotencyPolicy::ListResourcePolicies(
    google::cloud::cpp::compute::resource_policies::v1::
        ListResourcePoliciesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency ResourcePoliciesConnectionIdempotencyPolicy::PatchResourcePolicy(
    google::cloud::cpp::compute::resource_policies::v1::
        PatchResourcePolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ResourcePoliciesConnectionIdempotencyPolicy::SetIamPolicy(
    google::cloud::cpp::compute::resource_policies::v1::
        SetIamPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ResourcePoliciesConnectionIdempotencyPolicy::TestIamPermissions(
    google::cloud::cpp::compute::resource_policies::v1::
        TestIamPermissionsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<ResourcePoliciesConnectionIdempotencyPolicy>
MakeDefaultResourcePoliciesConnectionIdempotencyPolicy() {
  return std::make_unique<ResourcePoliciesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_resource_policies_v1
}  // namespace cloud
}  // namespace google
