// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/routes/v1/routes.proto

#include "google/cloud/compute/routes/v1/internal/routes_rest_metadata_decorator.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/internal/rest_set_metadata.h"
#include "google/cloud/status_or.h"
#include "absl/strings/str_format.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_routes_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

RoutesRestMetadata::RoutesRestMetadata(std::shared_ptr<RoutesRestStub> child,
                                       std::string api_client_header)
    : child_(std::move(child)),
      api_client_header_(
          api_client_header.empty()
              ? google::cloud::internal::GeneratedLibClientHeader()
              : std::move(api_client_header)) {}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RoutesRestMetadata::AsyncDeleteRoute(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::routes::v1::DeleteRouteRequest const&
        request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncDeleteRoute(cq, std::move(rest_context),
                                  std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
RoutesRestMetadata::DeleteRoute(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::routes::v1::DeleteRouteRequest const&
        request) {
  SetMetadata(rest_context, options);
  return child_->DeleteRoute(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::Route> RoutesRestMetadata::GetRoute(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::routes::v1::GetRouteRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->GetRoute(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RoutesRestMetadata::AsyncInsertRoute(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::routes::v1::InsertRouteRequest const&
        request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncInsertRoute(cq, std::move(rest_context),
                                  std::move(options), request);
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
RoutesRestMetadata::InsertRoute(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::routes::v1::InsertRouteRequest const&
        request) {
  SetMetadata(rest_context, options);
  return child_->InsertRoute(rest_context, options, request);
}

StatusOr<google::cloud::cpp::compute::v1::RouteList>
RoutesRestMetadata::ListRoutes(
    rest_internal::RestContext& rest_context, Options const& options,
    google::cloud::cpp::compute::routes::v1::ListRoutesRequest const& request) {
  SetMetadata(rest_context, options);
  return child_->ListRoutes(rest_context, options, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
RoutesRestMetadata::AsyncGetOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::global_operations::v1::
        GetOperationRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncGetOperation(cq, std::move(rest_context),
                                   std::move(options), request);
}

future<Status> RoutesRestMetadata::AsyncCancelOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::cpp::compute::global_operations::v1::
        DeleteOperationRequest const& request) {
  SetMetadata(*rest_context, *options);
  return child_->AsyncCancelOperation(cq, std::move(rest_context),
                                      std::move(options), request);
}

void RoutesRestMetadata::SetMetadata(rest_internal::RestContext& rest_context,
                                     Options const& options,
                                     std::vector<std::string> const& params) {
  google::cloud::rest_internal::SetMetadata(rest_context, options, params,
                                            api_client_header_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_routes_v1_internal
}  // namespace cloud
}  // namespace google
