// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/service_attachments/v1/service_attachments.proto

#include "google/cloud/compute/service_attachments/v1/internal/service_attachments_option_defaults.h"
#include "google/cloud/compute/service_attachments/v1/service_attachments_connection.h"
#include "google/cloud/compute/service_attachments/v1/service_attachments_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_service_attachments_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options ServiceAttachmentsDefaultOptions(Options options) {
  options = internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_SERVICE_ATTACHMENTS_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_SERVICE_ATTACHMENTS_AUTHORITY",
      "compute.googleapis.com");
  options = internal::PopulateGrpcOptions(std::move(options));
  if (!options.has<compute_service_attachments_v1::
                       ServiceAttachmentsRetryPolicyOption>()) {
    options.set<
        compute_service_attachments_v1::ServiceAttachmentsRetryPolicyOption>(
        compute_service_attachments_v1::
            ServiceAttachmentsLimitedTimeRetryPolicy(std::chrono::minutes(30))
                .clone());
  }
  if (!options.has<compute_service_attachments_v1::
                       ServiceAttachmentsBackoffPolicyOption>()) {
    options.set<
        compute_service_attachments_v1::ServiceAttachmentsBackoffPolicyOption>(
        ExponentialBackoffPolicy(
            std::chrono::seconds(0), std::chrono::seconds(1),
            std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
            .clone());
  }
  if (!options.has<compute_service_attachments_v1::
                       ServiceAttachmentsPollingPolicyOption>()) {
    options.set<
        compute_service_attachments_v1::ServiceAttachmentsPollingPolicyOption>(
        GenericPollingPolicy<compute_service_attachments_v1::
                                 ServiceAttachmentsRetryPolicyOption::Type,
                             compute_service_attachments_v1::
                                 ServiceAttachmentsBackoffPolicyOption::Type>(
            options
                .get<compute_service_attachments_v1::
                         ServiceAttachmentsRetryPolicyOption>()
                ->clone(),
            ExponentialBackoffPolicy(std::chrono::seconds(1),
                                     std::chrono::minutes(5), kBackoffScaling)
                .clone())
            .clone());
  }
  if (!options.has<compute_service_attachments_v1::
                       ServiceAttachmentsConnectionIdempotencyPolicyOption>()) {
    options.set<compute_service_attachments_v1::
                    ServiceAttachmentsConnectionIdempotencyPolicyOption>(
        compute_service_attachments_v1::
            MakeDefaultServiceAttachmentsConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_service_attachments_v1_internal
}  // namespace cloud
}  // namespace google
