// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/snapshots/v1/snapshots.proto

#include "google/cloud/compute/snapshots/v1/snapshots_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_snapshots_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

SnapshotsConnectionIdempotencyPolicy::~SnapshotsConnectionIdempotencyPolicy() =
    default;

std::unique_ptr<SnapshotsConnectionIdempotencyPolicy>
SnapshotsConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<SnapshotsConnectionIdempotencyPolicy>(*this);
}

Idempotency SnapshotsConnectionIdempotencyPolicy::DeleteSnapshot(
    google::cloud::cpp::compute::snapshots::v1::DeleteSnapshotRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SnapshotsConnectionIdempotencyPolicy::GetSnapshot(
    google::cloud::cpp::compute::snapshots::v1::GetSnapshotRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency SnapshotsConnectionIdempotencyPolicy::GetIamPolicy(
    google::cloud::cpp::compute::snapshots::v1::GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency SnapshotsConnectionIdempotencyPolicy::InsertSnapshot(
    google::cloud::cpp::compute::snapshots::v1::InsertSnapshotRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SnapshotsConnectionIdempotencyPolicy::ListSnapshots(
    google::cloud::cpp::compute::snapshots::v1::
        ListSnapshotsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency SnapshotsConnectionIdempotencyPolicy::SetIamPolicy(
    google::cloud::cpp::compute::snapshots::v1::SetIamPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SnapshotsConnectionIdempotencyPolicy::SetLabels(
    google::cloud::cpp::compute::snapshots::v1::SetLabelsRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SnapshotsConnectionIdempotencyPolicy::TestIamPermissions(
    google::cloud::cpp::compute::snapshots::v1::
        TestIamPermissionsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<SnapshotsConnectionIdempotencyPolicy>
MakeDefaultSnapshotsConnectionIdempotencyPolicy() {
  return std::make_unique<SnapshotsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_snapshots_v1
}  // namespace cloud
}  // namespace google
