// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/target_http_proxies/v1/target_http_proxies.proto

#include "google/cloud/compute/target_http_proxies/v1/internal/target_http_proxies_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace compute_target_http_proxies_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

TargetHttpProxiesTracingConnection::TargetHttpProxiesTracingConnection(
    std::shared_ptr<compute_target_http_proxies_v1::TargetHttpProxiesConnection>
        child)
    : child_(std::move(child)) {}

StreamRange<std::pair<
    std::string, google::cloud::cpp::compute::v1::TargetHttpProxiesScopedList>>
TargetHttpProxiesTracingConnection::AggregatedListTargetHttpProxies(
    google::cloud::cpp::compute::target_http_proxies::v1::
        AggregatedListTargetHttpProxiesRequest request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "AggregatedListTargetHttpProxies");
  internal::OTelScope scope(span);
  auto sr = child_->AggregatedListTargetHttpProxies(std::move(request));
  return internal::MakeTracedStreamRange<
      std::pair<std::string,
                google::cloud::cpp::compute::v1::TargetHttpProxiesScopedList>>(
      std::move(span), std::move(sr));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
TargetHttpProxiesTracingConnection::DeleteTargetHttpProxy(
    google::cloud::cpp::compute::target_http_proxies::v1::
        DeleteTargetHttpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "DeleteTargetHttpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteTargetHttpProxy(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
TargetHttpProxiesTracingConnection::DeleteTargetHttpProxy(
    NoAwaitTag, google::cloud::cpp::compute::target_http_proxies::v1::
                    DeleteTargetHttpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "DeleteTargetHttpProxy");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(
      *span, child_->DeleteTargetHttpProxy(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
TargetHttpProxiesTracingConnection::DeleteTargetHttpProxy(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "DeleteTargetHttpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteTargetHttpProxy(operation));
}

StatusOr<google::cloud::cpp::compute::v1::TargetHttpProxy>
TargetHttpProxiesTracingConnection::GetTargetHttpProxy(
    google::cloud::cpp::compute::target_http_proxies::v1::
        GetTargetHttpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "GetTargetHttpProxy");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetTargetHttpProxy(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
TargetHttpProxiesTracingConnection::InsertTargetHttpProxy(
    google::cloud::cpp::compute::target_http_proxies::v1::
        InsertTargetHttpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "InsertTargetHttpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertTargetHttpProxy(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
TargetHttpProxiesTracingConnection::InsertTargetHttpProxy(
    NoAwaitTag, google::cloud::cpp::compute::target_http_proxies::v1::
                    InsertTargetHttpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "InsertTargetHttpProxy");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(
      *span, child_->InsertTargetHttpProxy(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
TargetHttpProxiesTracingConnection::InsertTargetHttpProxy(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "InsertTargetHttpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertTargetHttpProxy(operation));
}

StreamRange<google::cloud::cpp::compute::v1::TargetHttpProxy>
TargetHttpProxiesTracingConnection::ListTargetHttpProxies(
    google::cloud::cpp::compute::target_http_proxies::v1::
        ListTargetHttpProxiesRequest request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "ListTargetHttpProxies");
  internal::OTelScope scope(span);
  auto sr = child_->ListTargetHttpProxies(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::cpp::compute::v1::TargetHttpProxy>(std::move(span),
                                                        std::move(sr));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
TargetHttpProxiesTracingConnection::PatchTargetHttpProxy(
    google::cloud::cpp::compute::target_http_proxies::v1::
        PatchTargetHttpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "PatchTargetHttpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->PatchTargetHttpProxy(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
TargetHttpProxiesTracingConnection::PatchTargetHttpProxy(
    NoAwaitTag, google::cloud::cpp::compute::target_http_proxies::v1::
                    PatchTargetHttpProxyRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "PatchTargetHttpProxy");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->PatchTargetHttpProxy(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
TargetHttpProxiesTracingConnection::PatchTargetHttpProxy(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::"
      "PatchTargetHttpProxy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->PatchTargetHttpProxy(operation));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
TargetHttpProxiesTracingConnection::SetUrlMap(
    google::cloud::cpp::compute::target_http_proxies::v1::
        SetUrlMapRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::SetUrlMap");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->SetUrlMap(request));
}

StatusOr<google::cloud::cpp::compute::v1::Operation>
TargetHttpProxiesTracingConnection::SetUrlMap(
    NoAwaitTag, google::cloud::cpp::compute::target_http_proxies::v1::
                    SetUrlMapRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::SetUrlMap");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span, child_->SetUrlMap(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
TargetHttpProxiesTracingConnection::SetUrlMap(
    google::cloud::cpp::compute::v1::Operation const& operation) {
  auto span = internal::MakeSpan(
      "compute_target_http_proxies_v1::TargetHttpProxiesConnection::SetUrlMap");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->SetUrlMap(operation));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<compute_target_http_proxies_v1::TargetHttpProxiesConnection>
MakeTargetHttpProxiesTracingConnection(
    std::shared_ptr<compute_target_http_proxies_v1::TargetHttpProxiesConnection>
        conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn =
        std::make_shared<TargetHttpProxiesTracingConnection>(std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_target_http_proxies_v1_internal
}  // namespace cloud
}  // namespace google
