// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/target_http_proxies/v1/target_http_proxies.proto

#include "google/cloud/compute/target_http_proxies/v1/target_http_proxies_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_target_http_proxies_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

TargetHttpProxiesConnectionIdempotencyPolicy::
    ~TargetHttpProxiesConnectionIdempotencyPolicy() = default;

std::unique_ptr<TargetHttpProxiesConnectionIdempotencyPolicy>
TargetHttpProxiesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<TargetHttpProxiesConnectionIdempotencyPolicy>(*this);
}

Idempotency
TargetHttpProxiesConnectionIdempotencyPolicy::AggregatedListTargetHttpProxies(
    google::cloud::cpp::compute::target_http_proxies::v1::
        AggregatedListTargetHttpProxiesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency TargetHttpProxiesConnectionIdempotencyPolicy::DeleteTargetHttpProxy(
    google::cloud::cpp::compute::target_http_proxies::v1::
        DeleteTargetHttpProxyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetHttpProxiesConnectionIdempotencyPolicy::GetTargetHttpProxy(
    google::cloud::cpp::compute::target_http_proxies::v1::
        GetTargetHttpProxyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency TargetHttpProxiesConnectionIdempotencyPolicy::InsertTargetHttpProxy(
    google::cloud::cpp::compute::target_http_proxies::v1::
        InsertTargetHttpProxyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetHttpProxiesConnectionIdempotencyPolicy::ListTargetHttpProxies(
    google::cloud::cpp::compute::target_http_proxies::v1::
        ListTargetHttpProxiesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency TargetHttpProxiesConnectionIdempotencyPolicy::PatchTargetHttpProxy(
    google::cloud::cpp::compute::target_http_proxies::v1::
        PatchTargetHttpProxyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetHttpProxiesConnectionIdempotencyPolicy::SetUrlMap(
    google::cloud::cpp::compute::target_http_proxies::v1::
        SetUrlMapRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<TargetHttpProxiesConnectionIdempotencyPolicy>
MakeDefaultTargetHttpProxiesConnectionIdempotencyPolicy() {
  return std::make_unique<TargetHttpProxiesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_target_http_proxies_v1
}  // namespace cloud
}  // namespace google
