// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/target_https_proxies/v1/target_https_proxies.proto

#include "google/cloud/compute/target_https_proxies/v1/target_https_proxies_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_target_https_proxies_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

TargetHttpsProxiesConnectionIdempotencyPolicy::
    ~TargetHttpsProxiesConnectionIdempotencyPolicy() = default;

std::unique_ptr<TargetHttpsProxiesConnectionIdempotencyPolicy>
TargetHttpsProxiesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<TargetHttpsProxiesConnectionIdempotencyPolicy>(*this);
}

Idempotency
TargetHttpsProxiesConnectionIdempotencyPolicy::AggregatedListTargetHttpsProxies(
    google::cloud::cpp::compute::target_https_proxies::v1::
        AggregatedListTargetHttpsProxiesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
TargetHttpsProxiesConnectionIdempotencyPolicy::DeleteTargetHttpsProxy(
    google::cloud::cpp::compute::target_https_proxies::v1::
        DeleteTargetHttpsProxyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetHttpsProxiesConnectionIdempotencyPolicy::GetTargetHttpsProxy(
    google::cloud::cpp::compute::target_https_proxies::v1::
        GetTargetHttpsProxyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
TargetHttpsProxiesConnectionIdempotencyPolicy::InsertTargetHttpsProxy(
    google::cloud::cpp::compute::target_https_proxies::v1::
        InsertTargetHttpsProxyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
TargetHttpsProxiesConnectionIdempotencyPolicy::ListTargetHttpsProxies(
    google::cloud::cpp::compute::target_https_proxies::v1::
        ListTargetHttpsProxiesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
TargetHttpsProxiesConnectionIdempotencyPolicy::PatchTargetHttpsProxy(
    google::cloud::cpp::compute::target_https_proxies::v1::
        PatchTargetHttpsProxyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetHttpsProxiesConnectionIdempotencyPolicy::SetCertificateMap(
    google::cloud::cpp::compute::target_https_proxies::v1::
        SetCertificateMapRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetHttpsProxiesConnectionIdempotencyPolicy::SetQuicOverride(
    google::cloud::cpp::compute::target_https_proxies::v1::
        SetQuicOverrideRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetHttpsProxiesConnectionIdempotencyPolicy::SetSslCertificates(
    google::cloud::cpp::compute::target_https_proxies::v1::
        SetSslCertificatesRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetHttpsProxiesConnectionIdempotencyPolicy::SetSslPolicy(
    google::cloud::cpp::compute::target_https_proxies::v1::
        SetSslPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetHttpsProxiesConnectionIdempotencyPolicy::SetUrlMap(
    google::cloud::cpp::compute::target_https_proxies::v1::
        SetUrlMapRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<TargetHttpsProxiesConnectionIdempotencyPolicy>
MakeDefaultTargetHttpsProxiesConnectionIdempotencyPolicy() {
  return std::make_unique<TargetHttpsProxiesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_target_https_proxies_v1
}  // namespace cloud
}  // namespace google
