// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/target_vpn_gateways/v1/target_vpn_gateways.proto

#include "google/cloud/compute/target_vpn_gateways/v1/target_vpn_gateways_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_target_vpn_gateways_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

TargetVpnGatewaysConnectionIdempotencyPolicy::
    ~TargetVpnGatewaysConnectionIdempotencyPolicy() = default;

std::unique_ptr<TargetVpnGatewaysConnectionIdempotencyPolicy>
TargetVpnGatewaysConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<TargetVpnGatewaysConnectionIdempotencyPolicy>(*this);
}

Idempotency
TargetVpnGatewaysConnectionIdempotencyPolicy::AggregatedListTargetVpnGateways(
    google::cloud::cpp::compute::target_vpn_gateways::v1::
        AggregatedListTargetVpnGatewaysRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
TargetVpnGatewaysConnectionIdempotencyPolicy::DeleteTargetVpnGateway(
    google::cloud::cpp::compute::target_vpn_gateways::v1::
        DeleteTargetVpnGatewayRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetVpnGatewaysConnectionIdempotencyPolicy::GetTargetVpnGateway(
    google::cloud::cpp::compute::target_vpn_gateways::v1::
        GetTargetVpnGatewayRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
TargetVpnGatewaysConnectionIdempotencyPolicy::InsertTargetVpnGateway(
    google::cloud::cpp::compute::target_vpn_gateways::v1::
        InsertTargetVpnGatewayRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency TargetVpnGatewaysConnectionIdempotencyPolicy::ListTargetVpnGateways(
    google::cloud::cpp::compute::target_vpn_gateways::v1::
        ListTargetVpnGatewaysRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency TargetVpnGatewaysConnectionIdempotencyPolicy::SetLabels(
    google::cloud::cpp::compute::target_vpn_gateways::v1::
        SetLabelsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<TargetVpnGatewaysConnectionIdempotencyPolicy>
MakeDefaultTargetVpnGatewaysConnectionIdempotencyPolicy() {
  return std::make_unique<TargetVpnGatewaysConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_target_vpn_gateways_v1
}  // namespace cloud
}  // namespace google
