// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/confidentialcomputing/v1/service.proto

#include "google/cloud/confidentialcomputing/v1/internal/confidential_computing_option_defaults.h"
#include "google/cloud/confidentialcomputing/v1/confidential_computing_connection.h"
#include "google/cloud/confidentialcomputing/v1/confidential_computing_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace confidentialcomputing_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options ConfidentialComputingDefaultOptions(Options options) {
  options = internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_CONFIDENTIAL_COMPUTING_ENDPOINT",
      "", "GOOGLE_CLOUD_CPP_CONFIDENTIAL_COMPUTING_AUTHORITY",
      "confidentialcomputing.googleapis.com");
  options = internal::PopulateGrpcOptions(std::move(options));
  if (!options.has<
          confidentialcomputing_v1::ConfidentialComputingRetryPolicyOption>()) {
    options.set<
        confidentialcomputing_v1::ConfidentialComputingRetryPolicyOption>(
        confidentialcomputing_v1::ConfidentialComputingLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<confidentialcomputing_v1::
                       ConfidentialComputingBackoffPolicyOption>()) {
    options.set<
        confidentialcomputing_v1::ConfidentialComputingBackoffPolicyOption>(
        ExponentialBackoffPolicy(
            std::chrono::seconds(0), std::chrono::seconds(1),
            std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
            .clone());
  }
  if (!options
           .has<confidentialcomputing_v1::
                    ConfidentialComputingConnectionIdempotencyPolicyOption>()) {
    options.set<confidentialcomputing_v1::
                    ConfidentialComputingConnectionIdempotencyPolicyOption>(
        confidentialcomputing_v1::
            MakeDefaultConfidentialComputingConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace confidentialcomputing_v1_internal
}  // namespace cloud
}  // namespace google
