// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/container/v1/cluster_service.proto

#include "google/cloud/container/v1/internal/cluster_manager_stub.h"
#include "google/cloud/grpc_error_delegate.h"
#include "google/cloud/status_or.h"
#include <google/container/v1/cluster_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace container_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

ClusterManagerStub::~ClusterManagerStub() = default;

StatusOr<google::container::v1::ListClustersResponse>
DefaultClusterManagerStub::ListClusters(
    grpc::ClientContext& context, Options const&,
    google::container::v1::ListClustersRequest const& request) {
  google::container::v1::ListClustersResponse response;
  auto status = grpc_stub_->ListClusters(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Cluster> DefaultClusterManagerStub::GetCluster(
    grpc::ClientContext& context, Options const&,
    google::container::v1::GetClusterRequest const& request) {
  google::container::v1::Cluster response;
  auto status = grpc_stub_->GetCluster(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::CreateCluster(
    grpc::ClientContext& context, Options const&,
    google::container::v1::CreateClusterRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->CreateCluster(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::UpdateCluster(
    grpc::ClientContext& context, Options const&,
    google::container::v1::UpdateClusterRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->UpdateCluster(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::UpdateNodePool(
    grpc::ClientContext& context, Options const&,
    google::container::v1::UpdateNodePoolRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->UpdateNodePool(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetNodePoolAutoscaling(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetNodePoolAutoscalingRequest const& request) {
  google::container::v1::Operation response;
  auto status =
      grpc_stub_->SetNodePoolAutoscaling(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetLoggingService(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetLoggingServiceRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetLoggingService(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetMonitoringService(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetMonitoringServiceRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetMonitoringService(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetAddonsConfig(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetAddonsConfigRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetAddonsConfig(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetLocations(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetLocationsRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetLocations(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::UpdateMaster(
    grpc::ClientContext& context, Options const&,
    google::container::v1::UpdateMasterRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->UpdateMaster(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetMasterAuth(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetMasterAuthRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetMasterAuth(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::DeleteCluster(
    grpc::ClientContext& context, Options const&,
    google::container::v1::DeleteClusterRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->DeleteCluster(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::ListOperationsResponse>
DefaultClusterManagerStub::ListOperations(
    grpc::ClientContext& context, Options const&,
    google::container::v1::ListOperationsRequest const& request) {
  google::container::v1::ListOperationsResponse response;
  auto status = grpc_stub_->ListOperations(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::GetOperation(
    grpc::ClientContext& context, Options const&,
    google::container::v1::GetOperationRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->GetOperation(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

Status DefaultClusterManagerStub::CancelOperation(
    grpc::ClientContext& context, Options const&,
    google::container::v1::CancelOperationRequest const& request) {
  google::protobuf::Empty response;
  auto status = grpc_stub_->CancelOperation(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return google::cloud::Status();
}

StatusOr<google::container::v1::ServerConfig>
DefaultClusterManagerStub::GetServerConfig(
    grpc::ClientContext& context, Options const&,
    google::container::v1::GetServerConfigRequest const& request) {
  google::container::v1::ServerConfig response;
  auto status = grpc_stub_->GetServerConfig(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::GetJSONWebKeysResponse>
DefaultClusterManagerStub::GetJSONWebKeys(
    grpc::ClientContext& context, Options const&,
    google::container::v1::GetJSONWebKeysRequest const& request) {
  google::container::v1::GetJSONWebKeysResponse response;
  auto status = grpc_stub_->GetJSONWebKeys(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::ListNodePoolsResponse>
DefaultClusterManagerStub::ListNodePools(
    grpc::ClientContext& context, Options const&,
    google::container::v1::ListNodePoolsRequest const& request) {
  google::container::v1::ListNodePoolsResponse response;
  auto status = grpc_stub_->ListNodePools(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::NodePool>
DefaultClusterManagerStub::GetNodePool(
    grpc::ClientContext& context, Options const&,
    google::container::v1::GetNodePoolRequest const& request) {
  google::container::v1::NodePool response;
  auto status = grpc_stub_->GetNodePool(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::CreateNodePool(
    grpc::ClientContext& context, Options const&,
    google::container::v1::CreateNodePoolRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->CreateNodePool(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::DeleteNodePool(
    grpc::ClientContext& context, Options const&,
    google::container::v1::DeleteNodePoolRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->DeleteNodePool(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

Status DefaultClusterManagerStub::CompleteNodePoolUpgrade(
    grpc::ClientContext& context, Options const&,
    google::container::v1::CompleteNodePoolUpgradeRequest const& request) {
  google::protobuf::Empty response;
  auto status =
      grpc_stub_->CompleteNodePoolUpgrade(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return google::cloud::Status();
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::RollbackNodePoolUpgrade(
    grpc::ClientContext& context, Options const&,
    google::container::v1::RollbackNodePoolUpgradeRequest const& request) {
  google::container::v1::Operation response;
  auto status =
      grpc_stub_->RollbackNodePoolUpgrade(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetNodePoolManagement(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetNodePoolManagementRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetNodePoolManagement(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation> DefaultClusterManagerStub::SetLabels(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetLabelsRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetLabels(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetLegacyAbac(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetLegacyAbacRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetLegacyAbac(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::StartIPRotation(
    grpc::ClientContext& context, Options const&,
    google::container::v1::StartIPRotationRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->StartIPRotation(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::CompleteIPRotation(
    grpc::ClientContext& context, Options const&,
    google::container::v1::CompleteIPRotationRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->CompleteIPRotation(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetNodePoolSize(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetNodePoolSizeRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetNodePoolSize(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetNetworkPolicy(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetNetworkPolicyRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetNetworkPolicy(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::Operation>
DefaultClusterManagerStub::SetMaintenancePolicy(
    grpc::ClientContext& context, Options const&,
    google::container::v1::SetMaintenancePolicyRequest const& request) {
  google::container::v1::Operation response;
  auto status = grpc_stub_->SetMaintenancePolicy(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::ListUsableSubnetworksResponse>
DefaultClusterManagerStub::ListUsableSubnetworks(
    grpc::ClientContext& context, Options const&,
    google::container::v1::ListUsableSubnetworksRequest const& request) {
  google::container::v1::ListUsableSubnetworksResponse response;
  auto status = grpc_stub_->ListUsableSubnetworks(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::container::v1::CheckAutopilotCompatibilityResponse>
DefaultClusterManagerStub::CheckAutopilotCompatibility(
    grpc::ClientContext& context, Options const&,
    google::container::v1::CheckAutopilotCompatibilityRequest const& request) {
  google::container::v1::CheckAutopilotCompatibilityResponse response;
  auto status =
      grpc_stub_->CheckAutopilotCompatibility(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace container_v1_internal
}  // namespace cloud
}  // namespace google
