// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/contentwarehouse/v1/ruleset_service.proto

#include "google/cloud/contentwarehouse/v1/rule_set_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace contentwarehouse_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

RuleSetServiceConnectionIdempotencyPolicy::
    ~RuleSetServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<RuleSetServiceConnectionIdempotencyPolicy>
RuleSetServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<RuleSetServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency RuleSetServiceConnectionIdempotencyPolicy::CreateRuleSet(
    google::cloud::contentwarehouse::v1::CreateRuleSetRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RuleSetServiceConnectionIdempotencyPolicy::GetRuleSet(
    google::cloud::contentwarehouse::v1::GetRuleSetRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency RuleSetServiceConnectionIdempotencyPolicy::UpdateRuleSet(
    google::cloud::contentwarehouse::v1::UpdateRuleSetRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RuleSetServiceConnectionIdempotencyPolicy::DeleteRuleSet(
    google::cloud::contentwarehouse::v1::DeleteRuleSetRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RuleSetServiceConnectionIdempotencyPolicy::ListRuleSets(
    google::cloud::contentwarehouse::v1::ListRuleSetsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency RuleSetServiceConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

std::unique_ptr<RuleSetServiceConnectionIdempotencyPolicy>
MakeDefaultRuleSetServiceConnectionIdempotencyPolicy() {
  return std::make_unique<RuleSetServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace contentwarehouse_v1
}  // namespace cloud
}  // namespace google
