// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/contentwarehouse/v1/synonymset_service.proto

#include "google/cloud/contentwarehouse/v1/synonym_set_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace contentwarehouse_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

SynonymSetServiceConnectionIdempotencyPolicy::
    ~SynonymSetServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<SynonymSetServiceConnectionIdempotencyPolicy>
SynonymSetServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<SynonymSetServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency SynonymSetServiceConnectionIdempotencyPolicy::CreateSynonymSet(
    google::cloud::contentwarehouse::v1::CreateSynonymSetRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SynonymSetServiceConnectionIdempotencyPolicy::GetSynonymSet(
    google::cloud::contentwarehouse::v1::GetSynonymSetRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency SynonymSetServiceConnectionIdempotencyPolicy::UpdateSynonymSet(
    google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SynonymSetServiceConnectionIdempotencyPolicy::DeleteSynonymSet(
    google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SynonymSetServiceConnectionIdempotencyPolicy::ListSynonymSets(
    google::cloud::contentwarehouse::v1::ListSynonymSetsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency SynonymSetServiceConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

std::unique_ptr<SynonymSetServiceConnectionIdempotencyPolicy>
MakeDefaultSynonymSetServiceConnectionIdempotencyPolicy() {
  return std::make_unique<SynonymSetServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace contentwarehouse_v1
}  // namespace cloud
}  // namespace google
