// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/clouddms/v1/clouddms.proto

#include "google/cloud/datamigration/v1/internal/data_migration_logging_decorator.h"
#include "google/cloud/internal/log_wrapper.h"
#include "google/cloud/status_or.h"
#include <google/cloud/clouddms/v1/clouddms.grpc.pb.h>
#include <memory>
#include <set>
#include <string>
#include <utility>

namespace google {
namespace cloud {
namespace datamigration_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

DataMigrationServiceLogging::DataMigrationServiceLogging(
    std::shared_ptr<DataMigrationServiceStub> child,
    TracingOptions tracing_options, std::set<std::string> const&)
    : child_(std::move(child)), tracing_options_(std::move(tracing_options)) {}

StatusOr<google::cloud::clouddms::v1::ListMigrationJobsResponse>
DataMigrationServiceLogging::ListMigrationJobs(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::ListMigrationJobsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::ListMigrationJobsRequest const&
                 request) {
        return child_->ListMigrationJobs(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::MigrationJob>
DataMigrationServiceLogging::GetMigrationJob(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::GetMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::GetMigrationJobRequest const& request) {
        return child_->GetMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncCreateMigrationJob(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::CreateMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::CreateMigrationJobRequest const&
                 request) {
        return child_->AsyncCreateMigrationJob(cq, std::move(context),
                                               std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::CreateMigrationJob(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::CreateMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::CreateMigrationJobRequest const&
                 request) {
        return child_->CreateMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncUpdateMigrationJob(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::UpdateMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::UpdateMigrationJobRequest const&
                 request) {
        return child_->AsyncUpdateMigrationJob(cq, std::move(context),
                                               std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::UpdateMigrationJob(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::UpdateMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::UpdateMigrationJobRequest const&
                 request) {
        return child_->UpdateMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncDeleteMigrationJob(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::DeleteMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::DeleteMigrationJobRequest const&
                 request) {
        return child_->AsyncDeleteMigrationJob(cq, std::move(context),
                                               std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::DeleteMigrationJob(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::DeleteMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::DeleteMigrationJobRequest const&
                 request) {
        return child_->DeleteMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncStartMigrationJob(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::StartMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::StartMigrationJobRequest const&
                 request) {
        return child_->AsyncStartMigrationJob(cq, std::move(context),
                                              std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::StartMigrationJob(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::StartMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::StartMigrationJobRequest const&
                 request) {
        return child_->StartMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncStopMigrationJob(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::StopMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          google::cloud::CompletionQueue& cq,
          std::shared_ptr<grpc::ClientContext> context,
          google::cloud::internal::ImmutableOptions options,
          google::cloud::clouddms::v1::StopMigrationJobRequest const& request) {
        return child_->AsyncStopMigrationJob(cq, std::move(context),
                                             std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::StopMigrationJob(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::StopMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::StopMigrationJobRequest const& request) {
        return child_->StopMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncResumeMigrationJob(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::ResumeMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::ResumeMigrationJobRequest const&
                 request) {
        return child_->AsyncResumeMigrationJob(cq, std::move(context),
                                               std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::ResumeMigrationJob(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::ResumeMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::ResumeMigrationJobRequest const&
                 request) {
        return child_->ResumeMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncPromoteMigrationJob(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::PromoteMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::PromoteMigrationJobRequest const&
                 request) {
        return child_->AsyncPromoteMigrationJob(cq, std::move(context),
                                                std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::PromoteMigrationJob(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::PromoteMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::PromoteMigrationJobRequest const&
                 request) {
        return child_->PromoteMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncVerifyMigrationJob(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::VerifyMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::VerifyMigrationJobRequest const&
                 request) {
        return child_->AsyncVerifyMigrationJob(cq, std::move(context),
                                               std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::VerifyMigrationJob(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::VerifyMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::VerifyMigrationJobRequest const&
                 request) {
        return child_->VerifyMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncRestartMigrationJob(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::RestartMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::RestartMigrationJobRequest const&
                 request) {
        return child_->AsyncRestartMigrationJob(cq, std::move(context),
                                                std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::RestartMigrationJob(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::RestartMigrationJobRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::RestartMigrationJobRequest const&
                 request) {
        return child_->RestartMigrationJob(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::SshScript>
DataMigrationServiceLogging::GenerateSshScript(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::GenerateSshScriptRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::GenerateSshScriptRequest const&
                 request) {
        return child_->GenerateSshScript(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::TcpProxyScript>
DataMigrationServiceLogging::GenerateTcpProxyScript(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::GenerateTcpProxyScriptRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::GenerateTcpProxyScriptRequest const&
                 request) {
        return child_->GenerateTcpProxyScript(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::ListConnectionProfilesResponse>
DataMigrationServiceLogging::ListConnectionProfiles(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::ListConnectionProfilesRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::ListConnectionProfilesRequest const&
                 request) {
        return child_->ListConnectionProfiles(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::ConnectionProfile>
DataMigrationServiceLogging::GetConnectionProfile(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::GetConnectionProfileRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::GetConnectionProfileRequest const&
                 request) {
        return child_->GetConnectionProfile(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncCreateConnectionProfile(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::CreateConnectionProfileRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::CreateConnectionProfileRequest const&
                 request) {
        return child_->AsyncCreateConnectionProfile(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::CreateConnectionProfile(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::CreateConnectionProfileRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::CreateConnectionProfileRequest const&
                 request) {
        return child_->CreateConnectionProfile(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncUpdateConnectionProfile(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::UpdateConnectionProfileRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::UpdateConnectionProfileRequest const&
                 request) {
        return child_->AsyncUpdateConnectionProfile(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::UpdateConnectionProfile(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::UpdateConnectionProfileRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::UpdateConnectionProfileRequest const&
                 request) {
        return child_->UpdateConnectionProfile(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncDeleteConnectionProfile(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::DeleteConnectionProfileRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::DeleteConnectionProfileRequest const&
                 request) {
        return child_->AsyncDeleteConnectionProfile(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::DeleteConnectionProfile(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::DeleteConnectionProfileRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::DeleteConnectionProfileRequest const&
                 request) {
        return child_->DeleteConnectionProfile(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncCreatePrivateConnection(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::CreatePrivateConnectionRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::CreatePrivateConnectionRequest const&
                 request) {
        return child_->AsyncCreatePrivateConnection(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::CreatePrivateConnection(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::CreatePrivateConnectionRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::CreatePrivateConnectionRequest const&
                 request) {
        return child_->CreatePrivateConnection(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::PrivateConnection>
DataMigrationServiceLogging::GetPrivateConnection(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::GetPrivateConnectionRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::GetPrivateConnectionRequest const&
                 request) {
        return child_->GetPrivateConnection(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::ListPrivateConnectionsResponse>
DataMigrationServiceLogging::ListPrivateConnections(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::ListPrivateConnectionsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::ListPrivateConnectionsRequest const&
                 request) {
        return child_->ListPrivateConnections(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncDeletePrivateConnection(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::DeletePrivateConnectionRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::DeletePrivateConnectionRequest const&
                 request) {
        return child_->AsyncDeletePrivateConnection(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::DeletePrivateConnection(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::DeletePrivateConnectionRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::DeletePrivateConnectionRequest const&
                 request) {
        return child_->DeletePrivateConnection(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::ConversionWorkspace>
DataMigrationServiceLogging::GetConversionWorkspace(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::GetConversionWorkspaceRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::GetConversionWorkspaceRequest const&
                 request) {
        return child_->GetConversionWorkspace(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::ListConversionWorkspacesResponse>
DataMigrationServiceLogging::ListConversionWorkspaces(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::ListConversionWorkspacesRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::ListConversionWorkspacesRequest const&
                 request) {
        return child_->ListConversionWorkspaces(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncCreateConversionWorkspace(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::CreateConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          google::cloud::CompletionQueue& cq,
          std::shared_ptr<grpc::ClientContext> context,
          google::cloud::internal::ImmutableOptions options,
          google::cloud::clouddms::v1::CreateConversionWorkspaceRequest const&
              request) {
        return child_->AsyncCreateConversionWorkspace(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::CreateConversionWorkspace(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::CreateConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::CreateConversionWorkspaceRequest const&
              request) {
        return child_->CreateConversionWorkspace(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncUpdateConversionWorkspace(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::UpdateConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          google::cloud::CompletionQueue& cq,
          std::shared_ptr<grpc::ClientContext> context,
          google::cloud::internal::ImmutableOptions options,
          google::cloud::clouddms::v1::UpdateConversionWorkspaceRequest const&
              request) {
        return child_->AsyncUpdateConversionWorkspace(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::UpdateConversionWorkspace(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::UpdateConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::UpdateConversionWorkspaceRequest const&
              request) {
        return child_->UpdateConversionWorkspace(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncDeleteConversionWorkspace(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::DeleteConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          google::cloud::CompletionQueue& cq,
          std::shared_ptr<grpc::ClientContext> context,
          google::cloud::internal::ImmutableOptions options,
          google::cloud::clouddms::v1::DeleteConversionWorkspaceRequest const&
              request) {
        return child_->AsyncDeleteConversionWorkspace(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::DeleteConversionWorkspace(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::DeleteConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::DeleteConversionWorkspaceRequest const&
              request) {
        return child_->DeleteConversionWorkspace(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::MappingRule>
DataMigrationServiceLogging::CreateMappingRule(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::CreateMappingRuleRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::CreateMappingRuleRequest const&
                 request) {
        return child_->CreateMappingRule(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

Status DataMigrationServiceLogging::DeleteMappingRule(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::DeleteMappingRuleRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::DeleteMappingRuleRequest const&
                 request) {
        return child_->DeleteMappingRule(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::ListMappingRulesResponse>
DataMigrationServiceLogging::ListMappingRules(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::ListMappingRulesRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::ListMappingRulesRequest const& request) {
        return child_->ListMappingRules(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::MappingRule>
DataMigrationServiceLogging::GetMappingRule(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::GetMappingRuleRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::GetMappingRuleRequest const& request) {
        return child_->GetMappingRule(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncSeedConversionWorkspace(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::SeedConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::SeedConversionWorkspaceRequest const&
                 request) {
        return child_->AsyncSeedConversionWorkspace(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::SeedConversionWorkspace(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::SeedConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::SeedConversionWorkspaceRequest const&
                 request) {
        return child_->SeedConversionWorkspace(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncImportMappingRules(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::ImportMappingRulesRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::ImportMappingRulesRequest const&
                 request) {
        return child_->AsyncImportMappingRules(cq, std::move(context),
                                               std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::ImportMappingRules(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::ImportMappingRulesRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::ImportMappingRulesRequest const&
                 request) {
        return child_->ImportMappingRules(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncConvertConversionWorkspace(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::ConvertConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          google::cloud::CompletionQueue& cq,
          std::shared_ptr<grpc::ClientContext> context,
          google::cloud::internal::ImmutableOptions options,
          google::cloud::clouddms::v1::ConvertConversionWorkspaceRequest const&
              request) {
        return child_->AsyncConvertConversionWorkspace(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::ConvertConversionWorkspace(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::ConvertConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::ConvertConversionWorkspaceRequest const&
              request) {
        return child_->ConvertConversionWorkspace(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncCommitConversionWorkspace(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::CommitConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          google::cloud::CompletionQueue& cq,
          std::shared_ptr<grpc::ClientContext> context,
          google::cloud::internal::ImmutableOptions options,
          google::cloud::clouddms::v1::CommitConversionWorkspaceRequest const&
              request) {
        return child_->AsyncCommitConversionWorkspace(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::CommitConversionWorkspace(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::CommitConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::CommitConversionWorkspaceRequest const&
              request) {
        return child_->CommitConversionWorkspace(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncRollbackConversionWorkspace(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::RollbackConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          google::cloud::CompletionQueue& cq,
          std::shared_ptr<grpc::ClientContext> context,
          google::cloud::internal::ImmutableOptions options,
          google::cloud::clouddms::v1::RollbackConversionWorkspaceRequest const&
              request) {
        return child_->AsyncRollbackConversionWorkspace(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::RollbackConversionWorkspace(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::RollbackConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::RollbackConversionWorkspaceRequest const&
              request) {
        return child_->RollbackConversionWorkspace(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncApplyConversionWorkspace(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::cloud::clouddms::v1::ApplyConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::cloud::clouddms::v1::ApplyConversionWorkspaceRequest const&
                 request) {
        return child_->AsyncApplyConversionWorkspace(
            cq, std::move(context), std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::ApplyConversionWorkspace(
    grpc::ClientContext& context, Options options,
    google::cloud::clouddms::v1::ApplyConversionWorkspaceRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::ApplyConversionWorkspaceRequest const&
                 request) {
        return child_->ApplyConversionWorkspace(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::DescribeDatabaseEntitiesResponse>
DataMigrationServiceLogging::DescribeDatabaseEntities(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::DescribeDatabaseEntitiesRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::DescribeDatabaseEntitiesRequest const&
                 request) {
        return child_->DescribeDatabaseEntities(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::SearchBackgroundJobsResponse>
DataMigrationServiceLogging::SearchBackgroundJobs(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::SearchBackgroundJobsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::SearchBackgroundJobsRequest const&
                 request) {
        return child_->SearchBackgroundJobs(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<
    google::cloud::clouddms::v1::DescribeConversionWorkspaceRevisionsResponse>
DataMigrationServiceLogging::DescribeConversionWorkspaceRevisions(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::
        DescribeConversionWorkspaceRevisionsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::clouddms::v1::
                 DescribeConversionWorkspaceRevisionsRequest const& request) {
        return child_->DescribeConversionWorkspaceRevisions(context, options,
                                                            request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::clouddms::v1::FetchStaticIpsResponse>
DataMigrationServiceLogging::FetchStaticIps(
    grpc::ClientContext& context, Options const& options,
    google::cloud::clouddms::v1::FetchStaticIpsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context, Options const& options,
          google::cloud::clouddms::v1::FetchStaticIpsRequest const& request) {
        return child_->FetchStaticIps(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::location::ListLocationsResponse>
DataMigrationServiceLogging::ListLocations(
    grpc::ClientContext& context, Options const& options,
    google::cloud::location::ListLocationsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::location::ListLocationsRequest const& request) {
        return child_->ListLocations(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::cloud::location::Location>
DataMigrationServiceLogging::GetLocation(
    grpc::ClientContext& context, Options const& options,
    google::cloud::location::GetLocationRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::cloud::location::GetLocationRequest const& request) {
        return child_->GetLocation(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::iam::v1::Policy> DataMigrationServiceLogging::SetIamPolicy(
    grpc::ClientContext& context, Options const& options,
    google::iam::v1::SetIamPolicyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::iam::v1::SetIamPolicyRequest const& request) {
        return child_->SetIamPolicy(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::iam::v1::Policy> DataMigrationServiceLogging::GetIamPolicy(
    grpc::ClientContext& context, Options const& options,
    google::iam::v1::GetIamPolicyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::iam::v1::GetIamPolicyRequest const& request) {
        return child_->GetIamPolicy(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::iam::v1::TestIamPermissionsResponse>
DataMigrationServiceLogging::TestIamPermissions(
    grpc::ClientContext& context, Options const& options,
    google::iam::v1::TestIamPermissionsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::iam::v1::TestIamPermissionsRequest const& request) {
        return child_->TestIamPermissions(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::longrunning::ListOperationsResponse>
DataMigrationServiceLogging::ListOperations(
    grpc::ClientContext& context, Options const& options,
    google::longrunning::ListOperationsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::longrunning::ListOperationsRequest const& request) {
        return child_->ListOperations(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

StatusOr<google::longrunning::Operation>
DataMigrationServiceLogging::GetOperation(
    grpc::ClientContext& context, Options const& options,
    google::longrunning::GetOperationRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::longrunning::GetOperationRequest const& request) {
        return child_->GetOperation(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

Status DataMigrationServiceLogging::DeleteOperation(
    grpc::ClientContext& context, Options const& options,
    google::longrunning::DeleteOperationRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::longrunning::DeleteOperationRequest const& request) {
        return child_->DeleteOperation(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

Status DataMigrationServiceLogging::CancelOperation(
    grpc::ClientContext& context, Options const& options,
    google::longrunning::CancelOperationRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context, Options const& options,
             google::longrunning::CancelOperationRequest const& request) {
        return child_->CancelOperation(context, options, request);
      },
      context, options, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
DataMigrationServiceLogging::AsyncGetOperation(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::longrunning::GetOperationRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::longrunning::GetOperationRequest const& request) {
        return child_->AsyncGetOperation(cq, std::move(context),
                                         std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

future<Status> DataMigrationServiceLogging::AsyncCancelOperation(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::internal::ImmutableOptions options,
    google::longrunning::CancelOperationRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::internal::ImmutableOptions options,
             google::longrunning::CancelOperationRequest const& request) {
        return child_->AsyncCancelOperation(cq, std::move(context),
                                            std::move(options), request);
      },
      cq, std::move(context), std::move(options), request, __func__,
      tracing_options_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace datamigration_v1_internal
}  // namespace cloud
}  // namespace google
