// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataplex/v1/catalog.proto

#include "google/cloud/dataplex/v1/internal/catalog_option_defaults.h"
#include "google/cloud/dataplex/v1/catalog_connection.h"
#include "google/cloud/dataplex/v1/catalog_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace dataplex_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options CatalogServiceDefaultOptions(Options options) {
  options = internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_CATALOG_SERVICE_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_CATALOG_SERVICE_AUTHORITY", "dataplex.googleapis.com");
  options = internal::PopulateGrpcOptions(std::move(options));
  if (!options.has<dataplex_v1::CatalogServiceRetryPolicyOption>()) {
    options.set<dataplex_v1::CatalogServiceRetryPolicyOption>(
        dataplex_v1::CatalogServiceLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<dataplex_v1::CatalogServiceBackoffPolicyOption>()) {
    options.set<dataplex_v1::CatalogServiceBackoffPolicyOption>(
        ExponentialBackoffPolicy(
            std::chrono::seconds(0), std::chrono::seconds(1),
            std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
            .clone());
  }
  if (!options.has<dataplex_v1::CatalogServicePollingPolicyOption>()) {
    options.set<dataplex_v1::CatalogServicePollingPolicyOption>(
        GenericPollingPolicy<
            dataplex_v1::CatalogServiceRetryPolicyOption::Type,
            dataplex_v1::CatalogServiceBackoffPolicyOption::Type>(
            options.get<dataplex_v1::CatalogServiceRetryPolicyOption>()
                ->clone(),
            ExponentialBackoffPolicy(std::chrono::seconds(1),
                                     std::chrono::minutes(5), kBackoffScaling)
                .clone())
            .clone());
  }
  if (!options.has<
          dataplex_v1::CatalogServiceConnectionIdempotencyPolicyOption>()) {
    options.set<dataplex_v1::CatalogServiceConnectionIdempotencyPolicyOption>(
        dataplex_v1::MakeDefaultCatalogServiceConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataplex_v1_internal
}  // namespace cloud
}  // namespace google
