// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataproc/v1/jobs.proto

#include "google/cloud/dataproc/v1/job_controller_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace dataproc_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

JobControllerConnectionIdempotencyPolicy::
    ~JobControllerConnectionIdempotencyPolicy() = default;

std::unique_ptr<JobControllerConnectionIdempotencyPolicy>
JobControllerConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<JobControllerConnectionIdempotencyPolicy>(*this);
}

Idempotency JobControllerConnectionIdempotencyPolicy::SubmitJob(
    google::cloud::dataproc::v1::SubmitJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::SubmitJobAsOperation(
    google::cloud::dataproc::v1::SubmitJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::GetJob(
    google::cloud::dataproc::v1::GetJobRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::ListJobs(
    google::cloud::dataproc::v1::ListJobsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::UpdateJob(
    google::cloud::dataproc::v1::UpdateJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::CancelJob(
    google::cloud::dataproc::v1::CancelJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::DeleteJob(
    google::cloud::dataproc::v1::DeleteJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::SetIamPolicy(
    google::iam::v1::SetIamPolicyRequest const& request) {
  return request.policy().etag().empty() ? Idempotency::kNonIdempotent
                                         : Idempotency::kIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::GetIamPolicy(
    google::iam::v1::GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::TestIamPermissions(
    google::iam::v1::TestIamPermissionsRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::ListOperations(
    google::longrunning::ListOperationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::DeleteOperation(
    google::longrunning::DeleteOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency JobControllerConnectionIdempotencyPolicy::CancelOperation(
    google::longrunning::CancelOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<JobControllerConnectionIdempotencyPolicy>
MakeDefaultJobControllerConnectionIdempotencyPolicy() {
  return std::make_unique<JobControllerConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataproc_v1
}  // namespace cloud
}  // namespace google
