// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/datastore/v1/datastore.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DATASTORE_V1_MOCKS_MOCK_DATASTORE_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DATASTORE_V1_MOCKS_MOCK_DATASTORE_CONNECTION_H

#include "google/cloud/datastore/v1/datastore_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace datastore_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `DatastoreConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `DatastoreClient`. To do so,
 * construct an object of type `DatastoreClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockDatastoreConnection : public datastore_v1::DatastoreConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(StatusOr<google::datastore::v1::LookupResponse>, Lookup,
              (google::datastore::v1::LookupRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::datastore::v1::RunQueryResponse>, RunQuery,
              (google::datastore::v1::RunQueryRequest const& request),
              (override));

  MOCK_METHOD(
      StatusOr<google::datastore::v1::RunAggregationQueryResponse>,
      RunAggregationQuery,
      (google::datastore::v1::RunAggregationQueryRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::datastore::v1::BeginTransactionResponse>,
              BeginTransaction,
              (google::datastore::v1::BeginTransactionRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::datastore::v1::CommitResponse>, Commit,
              (google::datastore::v1::CommitRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::datastore::v1::RollbackResponse>, Rollback,
              (google::datastore::v1::RollbackRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::datastore::v1::AllocateIdsResponse>, AllocateIds,
              (google::datastore::v1::AllocateIdsRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::datastore::v1::ReserveIdsResponse>, ReserveIds,
              (google::datastore::v1::ReserveIdsRequest const& request),
              (override));

  MOCK_METHOD((StreamRange<google::longrunning::Operation>), ListOperations,
              (google::longrunning::ListOperationsRequest request), (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, GetOperation,
              (google::longrunning::GetOperationRequest const& request),
              (override));

  MOCK_METHOD(Status, DeleteOperation,
              (google::longrunning::DeleteOperationRequest const& request),
              (override));

  MOCK_METHOD(Status, CancelOperation,
              (google::longrunning::CancelOperationRequest const& request),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace datastore_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DATASTORE_V1_MOCKS_MOCK_DATASTORE_CONNECTION_H
