// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/version.proto

#include "google/cloud/dialogflow_es/versions_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

VersionsConnectionIdempotencyPolicy::~VersionsConnectionIdempotencyPolicy() =
    default;

std::unique_ptr<VersionsConnectionIdempotencyPolicy>
VersionsConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<VersionsConnectionIdempotencyPolicy>(*this);
}

Idempotency VersionsConnectionIdempotencyPolicy::ListVersions(
    google::cloud::dialogflow::v2::ListVersionsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency VersionsConnectionIdempotencyPolicy::GetVersion(
    google::cloud::dialogflow::v2::GetVersionRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency VersionsConnectionIdempotencyPolicy::CreateVersion(
    google::cloud::dialogflow::v2::CreateVersionRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency VersionsConnectionIdempotencyPolicy::UpdateVersion(
    google::cloud::dialogflow::v2::UpdateVersionRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency VersionsConnectionIdempotencyPolicy::DeleteVersion(
    google::cloud::dialogflow::v2::DeleteVersionRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency VersionsConnectionIdempotencyPolicy::ListLocations(
    google::cloud::location::ListLocationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency VersionsConnectionIdempotencyPolicy::GetLocation(
    google::cloud::location::GetLocationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency VersionsConnectionIdempotencyPolicy::ListOperations(
    google::longrunning::ListOperationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency VersionsConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency VersionsConnectionIdempotencyPolicy::CancelOperation(
    google::longrunning::CancelOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<VersionsConnectionIdempotencyPolicy>
MakeDefaultVersionsConnectionIdempotencyPolicy() {
  return std::make_unique<VersionsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google
