// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/discoveryengine/v1/control_service.proto

#include "google/cloud/discoveryengine/v1/internal/control_stub.h"
#include "google/cloud/grpc_error_delegate.h"
#include "google/cloud/status_or.h"
#include <google/cloud/discoveryengine/v1/control_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace discoveryengine_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

ControlServiceStub::~ControlServiceStub() = default;

StatusOr<google::cloud::discoveryengine::v1::Control>
DefaultControlServiceStub::CreateControl(
    grpc::ClientContext& context, Options const&,
    google::cloud::discoveryengine::v1::CreateControlRequest const& request) {
  google::cloud::discoveryengine::v1::Control response;
  auto status = grpc_stub_->CreateControl(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

Status DefaultControlServiceStub::DeleteControl(
    grpc::ClientContext& context, Options const&,
    google::cloud::discoveryengine::v1::DeleteControlRequest const& request) {
  google::protobuf::Empty response;
  auto status = grpc_stub_->DeleteControl(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return google::cloud::Status();
}

StatusOr<google::cloud::discoveryengine::v1::Control>
DefaultControlServiceStub::UpdateControl(
    grpc::ClientContext& context, Options const&,
    google::cloud::discoveryengine::v1::UpdateControlRequest const& request) {
  google::cloud::discoveryengine::v1::Control response;
  auto status = grpc_stub_->UpdateControl(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::discoveryengine::v1::Control>
DefaultControlServiceStub::GetControl(
    grpc::ClientContext& context, Options const&,
    google::cloud::discoveryengine::v1::GetControlRequest const& request) {
  google::cloud::discoveryengine::v1::Control response;
  auto status = grpc_stub_->GetControl(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::discoveryengine::v1::ListControlsResponse>
DefaultControlServiceStub::ListControls(
    grpc::ClientContext& context, Options const&,
    google::cloud::discoveryengine::v1::ListControlsRequest const& request) {
  google::cloud::discoveryengine::v1::ListControlsResponse response;
  auto status = grpc_stub_->ListControls(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::longrunning::ListOperationsResponse>
DefaultControlServiceStub::ListOperations(
    grpc::ClientContext& context, Options const&,
    google::longrunning::ListOperationsRequest const& request) {
  google::longrunning::ListOperationsResponse response;
  auto status = operations_stub_->ListOperations(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::longrunning::Operation>
DefaultControlServiceStub::GetOperation(
    grpc::ClientContext& context, Options const&,
    google::longrunning::GetOperationRequest const& request) {
  google::longrunning::Operation response;
  auto status = operations_stub_->GetOperation(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

Status DefaultControlServiceStub::CancelOperation(
    grpc::ClientContext& context, Options const&,
    google::longrunning::CancelOperationRequest const& request) {
  google::protobuf::Empty response;
  auto status = operations_stub_->CancelOperation(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return google::cloud::Status();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace discoveryengine_v1_internal
}  // namespace cloud
}  // namespace google
