// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/discoveryengine/v1/rank_service.proto

#include "google/cloud/discoveryengine/v1/internal/rank_option_defaults.h"
#include "google/cloud/discoveryengine/v1/rank_connection.h"
#include "google/cloud/discoveryengine/v1/rank_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace discoveryengine_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options RankServiceDefaultOptions(Options options) {
  options = internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_RANK_SERVICE_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_RANK_SERVICE_AUTHORITY",
      "discoveryengine.googleapis.com");
  options = internal::PopulateGrpcOptions(std::move(options));
  if (!options.has<discoveryengine_v1::RankServiceRetryPolicyOption>()) {
    options.set<discoveryengine_v1::RankServiceRetryPolicyOption>(
        discoveryengine_v1::RankServiceLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<discoveryengine_v1::RankServiceBackoffPolicyOption>()) {
    options.set<discoveryengine_v1::RankServiceBackoffPolicyOption>(
        ExponentialBackoffPolicy(
            std::chrono::seconds(0), std::chrono::seconds(1),
            std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
            .clone());
  }
  if (!options.has<
          discoveryengine_v1::RankServiceConnectionIdempotencyPolicyOption>()) {
    options
        .set<discoveryengine_v1::RankServiceConnectionIdempotencyPolicyOption>(
            discoveryengine_v1::
                MakeDefaultRankServiceConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace discoveryengine_v1_internal
}  // namespace cloud
}  // namespace google
