// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/eventarc/publishing/v1/publisher.proto

#include "google/cloud/eventarc/publishing/v1/internal/publisher_metadata_decorator.h"
#include "google/cloud/grpc_options.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/internal/url_encode.h"
#include "google/cloud/status_or.h"
#include <google/cloud/eventarc/publishing/v1/publisher.grpc.pb.h>
#include <memory>
#include <string>
#include <utility>
#include <vector>

namespace google {
namespace cloud {
namespace eventarc_publishing_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

PublisherMetadata::PublisherMetadata(
    std::shared_ptr<PublisherStub> child,
    std::multimap<std::string, std::string> fixed_metadata,
    std::string api_client_header)
    : child_(std::move(child)),
      fixed_metadata_(std::move(fixed_metadata)),
      api_client_header_(
          api_client_header.empty()
              ? google::cloud::internal::GeneratedLibClientHeader()
              : std::move(api_client_header)) {}

StatusOr<google::cloud::eventarc::publishing::v1::
             PublishChannelConnectionEventsResponse>
PublisherMetadata::PublishChannelConnectionEvents(
    grpc::ClientContext& context, Options const& options,
    google::cloud::eventarc::publishing::v1::
        PublishChannelConnectionEventsRequest const& request) {
  SetMetadata(context, options,
              absl::StrCat("channel_connection=",
                           internal::UrlEncode(request.channel_connection())));
  return child_->PublishChannelConnectionEvents(context, options, request);
}

StatusOr<google::cloud::eventarc::publishing::v1::PublishEventsResponse>
PublisherMetadata::PublishEvents(
    grpc::ClientContext& context, Options const& options,
    google::cloud::eventarc::publishing::v1::PublishEventsRequest const&
        request) {
  SetMetadata(context, options,
              absl::StrCat("channel=", internal::UrlEncode(request.channel())));
  return child_->PublishEvents(context, options, request);
}

StatusOr<google::cloud::eventarc::publishing::v1::PublishResponse>
PublisherMetadata::Publish(
    grpc::ClientContext& context, Options const& options,
    google::cloud::eventarc::publishing::v1::PublishRequest const& request) {
  SetMetadata(
      context, options,
      absl::StrCat("message_bus=", internal::UrlEncode(request.message_bus())));
  return child_->Publish(context, options, request);
}

void PublisherMetadata::SetMetadata(grpc::ClientContext& context,
                                    Options const& options,
                                    std::string const& request_params) {
  context.AddMetadata("x-goog-request-params", request_params);
  SetMetadata(context, options);
}

void PublisherMetadata::SetMetadata(grpc::ClientContext& context,
                                    Options const& options) {
  google::cloud::internal::SetMetadata(context, options, fixed_metadata_,
                                       api_client_header_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace eventarc_publishing_v1_internal
}  // namespace cloud
}  // namespace google
