// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/eventarc/publishing/v1/publisher.proto

#include "google/cloud/eventarc/publishing/v1/publisher_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace eventarc_publishing_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

PublisherConnectionIdempotencyPolicy::~PublisherConnectionIdempotencyPolicy() =
    default;

std::unique_ptr<PublisherConnectionIdempotencyPolicy>
PublisherConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<PublisherConnectionIdempotencyPolicy>(*this);
}

Idempotency
PublisherConnectionIdempotencyPolicy::PublishChannelConnectionEvents(
    google::cloud::eventarc::publishing::v1::
        PublishChannelConnectionEventsRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PublisherConnectionIdempotencyPolicy::PublishEvents(
    google::cloud::eventarc::publishing::v1::PublishEventsRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency PublisherConnectionIdempotencyPolicy::Publish(
    google::cloud::eventarc::publishing::v1::PublishRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<PublisherConnectionIdempotencyPolicy>
MakeDefaultPublisherConnectionIdempotencyPolicy() {
  return std::make_unique<PublisherConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace eventarc_publishing_v1
}  // namespace cloud
}  // namespace google
