// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/gkeconnect/gateway/v1/control.proto

#include "google/cloud/gkeconnect/gateway/v1/internal/gateway_control_option_defaults.h"
#include "google/cloud/gkeconnect/gateway/v1/gateway_control_connection.h"
#include "google/cloud/gkeconnect/gateway/v1/gateway_control_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace gkeconnect_gateway_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options GatewayControlDefaultOptions(Options options) {
  options = internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_GATEWAY_CONTROL_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_GATEWAY_CONTROL_AUTHORITY",
      "connectgateway.googleapis.com");
  options = internal::PopulateGrpcOptions(std::move(options));
  if (!options.has<gkeconnect_gateway_v1::GatewayControlRetryPolicyOption>()) {
    options.set<gkeconnect_gateway_v1::GatewayControlRetryPolicyOption>(
        gkeconnect_gateway_v1::GatewayControlLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options
           .has<gkeconnect_gateway_v1::GatewayControlBackoffPolicyOption>()) {
    options.set<gkeconnect_gateway_v1::GatewayControlBackoffPolicyOption>(
        ExponentialBackoffPolicy(
            std::chrono::seconds(0), std::chrono::seconds(1),
            std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
            .clone());
  }
  if (!options.has<gkeconnect_gateway_v1::
                       GatewayControlConnectionIdempotencyPolicyOption>()) {
    options.set<
        gkeconnect_gateway_v1::GatewayControlConnectionIdempotencyPolicyOption>(
        gkeconnect_gateway_v1::
            MakeDefaultGatewayControlConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace gkeconnect_gateway_v1_internal
}  // namespace cloud
}  // namespace google
