# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# DO NOT EDIT -- GENERATED BY CMake -- Change the CMakeLists.txt file if needed

"""Automatically generated source lists for google_cloud_cpp_rest_internal - DO NOT EDIT."""

google_cloud_cpp_rest_internal_hdrs = [
    "internal/binary_data_as_debug_string.h",
    "internal/curl_handle.h",
    "internal/curl_handle_factory.h",
    "internal/curl_http_payload.h",
    "internal/curl_impl.h",
    "internal/curl_options.h",
    "internal/curl_rest_client.h",
    "internal/curl_rest_response.h",
    "internal/curl_wrappers.h",
    "internal/curl_writev.h",
    "internal/external_account_source_format.h",
    "internal/external_account_token_source_aws.h",
    "internal/external_account_token_source_file.h",
    "internal/external_account_token_source_url.h",
    "internal/http_payload.h",
    "internal/json_parsing.h",
    "internal/make_jwt_assertion.h",
    "internal/oauth2_access_token_credentials.h",
    "internal/oauth2_anonymous_credentials.h",
    "internal/oauth2_api_key_credentials.h",
    "internal/oauth2_authorized_user_credentials.h",
    "internal/oauth2_cached_credentials.h",
    "internal/oauth2_compute_engine_credentials.h",
    "internal/oauth2_credential_constants.h",
    "internal/oauth2_credentials.h",
    "internal/oauth2_decorate_credentials.h",
    "internal/oauth2_error_credentials.h",
    "internal/oauth2_external_account_credentials.h",
    "internal/oauth2_external_account_token_source.h",
    "internal/oauth2_google_application_default_credentials_file.h",
    "internal/oauth2_google_credentials.h",
    "internal/oauth2_http_client_factory.h",
    "internal/oauth2_impersonate_service_account_credentials.h",
    "internal/oauth2_logging_credentials.h",
    "internal/oauth2_minimal_iam_credentials_rest.h",
    "internal/oauth2_refreshing_credentials_wrapper.h",
    "internal/oauth2_service_account_credentials.h",
    "internal/oauth2_universe_domain.h",
    "internal/parse_service_account_p12_file.h",
    "internal/populate_rest_options.h",
    "internal/rest_carrier.h",
    "internal/rest_client.h",
    "internal/rest_context.h",
    "internal/rest_lro_helpers.h",
    "internal/rest_opentelemetry.h",
    "internal/rest_options.h",
    "internal/rest_parse_json_error.h",
    "internal/rest_request.h",
    "internal/rest_response.h",
    "internal/rest_retry_loop.h",
    "internal/rest_set_metadata.h",
    "internal/sign_using_sha256.h",
    "internal/tracing_http_payload.h",
    "internal/tracing_rest_client.h",
    "internal/tracing_rest_response.h",
    "internal/unified_rest_credentials.h",
    "internal/win32/win32_helpers.h",
    "rest_options.h",
]

google_cloud_cpp_rest_internal_srcs = [
    "internal/binary_data_as_debug_string.cc",
    "internal/curl_handle.cc",
    "internal/curl_handle_factory.cc",
    "internal/curl_http_payload.cc",
    "internal/curl_impl.cc",
    "internal/curl_rest_client.cc",
    "internal/curl_rest_response.cc",
    "internal/curl_wrappers.cc",
    "internal/curl_writev.cc",
    "internal/external_account_source_format.cc",
    "internal/external_account_token_source_aws.cc",
    "internal/external_account_token_source_file.cc",
    "internal/external_account_token_source_url.cc",
    "internal/json_parsing.cc",
    "internal/make_jwt_assertion.cc",
    "internal/oauth2_access_token_credentials.cc",
    "internal/oauth2_anonymous_credentials.cc",
    "internal/oauth2_api_key_credentials.cc",
    "internal/oauth2_authorized_user_credentials.cc",
    "internal/oauth2_cached_credentials.cc",
    "internal/oauth2_compute_engine_credentials.cc",
    "internal/oauth2_credentials.cc",
    "internal/oauth2_decorate_credentials.cc",
    "internal/oauth2_error_credentials.cc",
    "internal/oauth2_external_account_credentials.cc",
    "internal/oauth2_google_application_default_credentials_file.cc",
    "internal/oauth2_google_credentials.cc",
    "internal/oauth2_impersonate_service_account_credentials.cc",
    "internal/oauth2_logging_credentials.cc",
    "internal/oauth2_minimal_iam_credentials_rest.cc",
    "internal/oauth2_refreshing_credentials_wrapper.cc",
    "internal/oauth2_service_account_credentials.cc",
    "internal/oauth2_universe_domain.cc",
    "internal/openssl/parse_service_account_p12_file.cc",
    "internal/openssl/sign_using_sha256.cc",
    "internal/populate_rest_options.cc",
    "internal/rest_carrier.cc",
    "internal/rest_context.cc",
    "internal/rest_lro_helpers.cc",
    "internal/rest_opentelemetry.cc",
    "internal/rest_parse_json_error.cc",
    "internal/rest_request.cc",
    "internal/rest_response.cc",
    "internal/rest_set_metadata.cc",
    "internal/tracing_http_payload.cc",
    "internal/tracing_rest_client.cc",
    "internal/tracing_rest_response.cc",
    "internal/unified_rest_credentials.cc",
    "internal/win32/parse_service_account_p12_file.cc",
    "internal/win32/sign_using_sha256.cc",
    "internal/win32/win32_helpers.cc",
]
