// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/kms/inventory/v1/key_dashboard_service.proto

#include "google/cloud/kms/inventory/v1/internal/key_dashboard_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace kms_inventory_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

KeyDashboardServiceTracingConnection::KeyDashboardServiceTracingConnection(
    std::shared_ptr<kms_inventory_v1::KeyDashboardServiceConnection> child)
    : child_(std::move(child)) {}

StreamRange<google::cloud::kms::v1::CryptoKey>
KeyDashboardServiceTracingConnection::ListCryptoKeys(
    google::cloud::kms::inventory::v1::ListCryptoKeysRequest request) {
  auto span = internal::MakeSpan(
      "kms_inventory_v1::KeyDashboardServiceConnection::ListCryptoKeys");
  internal::OTelScope scope(span);
  auto sr = child_->ListCryptoKeys(std::move(request));
  return internal::MakeTracedStreamRange<google::cloud::kms::v1::CryptoKey>(
      std::move(span), std::move(sr));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<kms_inventory_v1::KeyDashboardServiceConnection>
MakeKeyDashboardServiceTracingConnection(
    std::shared_ptr<kms_inventory_v1::KeyDashboardServiceConnection> conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn =
        std::make_shared<KeyDashboardServiceTracingConnection>(std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace kms_inventory_v1_internal
}  // namespace cloud
}  // namespace google
