// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/kms/inventory/v1/key_tracking_service.proto

#include "google/cloud/kms/inventory/v1/internal/key_tracking_stub.h"
#include "google/cloud/grpc_error_delegate.h"
#include "google/cloud/status_or.h"
#include <google/cloud/kms/inventory/v1/key_tracking_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace kms_inventory_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

KeyTrackingServiceStub::~KeyTrackingServiceStub() = default;

StatusOr<google::cloud::kms::inventory::v1::ProtectedResourcesSummary>
DefaultKeyTrackingServiceStub::GetProtectedResourcesSummary(
    grpc::ClientContext& context, Options const&,
    google::cloud::kms::inventory::v1::
        GetProtectedResourcesSummaryRequest const& request) {
  google::cloud::kms::inventory::v1::ProtectedResourcesSummary response;
  auto status =
      grpc_stub_->GetProtectedResourcesSummary(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::kms::inventory::v1::SearchProtectedResourcesResponse>
DefaultKeyTrackingServiceStub::SearchProtectedResources(
    grpc::ClientContext& context, Options const&,
    google::cloud::kms::inventory::v1::SearchProtectedResourcesRequest const&
        request) {
  google::cloud::kms::inventory::v1::SearchProtectedResourcesResponse response;
  auto status =
      grpc_stub_->SearchProtectedResources(&context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace kms_inventory_v1_internal
}  // namespace cloud
}  // namespace google
