// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/kms/inventory/v1/key_dashboard_service.proto

#include "google/cloud/kms/inventory/v1/key_dashboard_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace kms_inventory_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

KeyDashboardServiceConnectionIdempotencyPolicy::
    ~KeyDashboardServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<KeyDashboardServiceConnectionIdempotencyPolicy>
KeyDashboardServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<KeyDashboardServiceConnectionIdempotencyPolicy>(
      *this);
}

Idempotency KeyDashboardServiceConnectionIdempotencyPolicy::ListCryptoKeys(
    google::cloud::kms::inventory::v1::ListCryptoKeysRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

std::unique_ptr<KeyDashboardServiceConnectionIdempotencyPolicy>
MakeDefaultKeyDashboardServiceConnectionIdempotencyPolicy() {
  return std::make_unique<KeyDashboardServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace kms_inventory_v1
}  // namespace cloud
}  // namespace google
