// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/kms/inventory/v1/key_tracking_service.proto

#include "google/cloud/kms/inventory/v1/key_tracking_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace kms_inventory_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

KeyTrackingServiceConnectionIdempotencyPolicy::
    ~KeyTrackingServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<KeyTrackingServiceConnectionIdempotencyPolicy>
KeyTrackingServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<KeyTrackingServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency
KeyTrackingServiceConnectionIdempotencyPolicy::GetProtectedResourcesSummary(
    google::cloud::kms::inventory::v1::
        GetProtectedResourcesSummaryRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
KeyTrackingServiceConnectionIdempotencyPolicy::SearchProtectedResources(
    google::cloud::kms::inventory::v1::
        SearchProtectedResourcesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

std::unique_ptr<KeyTrackingServiceConnectionIdempotencyPolicy>
MakeDefaultKeyTrackingServiceConnectionIdempotencyPolicy() {
  return std::make_unique<KeyTrackingServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace kms_inventory_v1
}  // namespace cloud
}  // namespace google
