// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/monitoring/dashboard/v1/dashboards_service.proto

#include "google/cloud/monitoring/dashboard/v1/dashboards_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace monitoring_dashboard_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

DashboardsServiceConnectionIdempotencyPolicy::
    ~DashboardsServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<DashboardsServiceConnectionIdempotencyPolicy>
DashboardsServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<DashboardsServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency DashboardsServiceConnectionIdempotencyPolicy::CreateDashboard(
    google::monitoring::dashboard::v1::CreateDashboardRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency DashboardsServiceConnectionIdempotencyPolicy::ListDashboards(
    google::monitoring::dashboard::v1::ListDashboardsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency DashboardsServiceConnectionIdempotencyPolicy::GetDashboard(
    google::monitoring::dashboard::v1::GetDashboardRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency DashboardsServiceConnectionIdempotencyPolicy::DeleteDashboard(
    google::monitoring::dashboard::v1::DeleteDashboardRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency DashboardsServiceConnectionIdempotencyPolicy::UpdateDashboard(
    google::monitoring::dashboard::v1::UpdateDashboardRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<DashboardsServiceConnectionIdempotencyPolicy>
MakeDefaultDashboardsServiceConnectionIdempotencyPolicy() {
  return std::make_unique<DashboardsServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace monitoring_dashboard_v1
}  // namespace cloud
}  // namespace google
