// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/monitoring/metricsscope/v1/metrics_scopes.proto

#include "google/cloud/monitoring/metricsscope/v1/metrics_scopes_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace monitoring_metricsscope_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

MetricsScopesConnectionIdempotencyPolicy::
    ~MetricsScopesConnectionIdempotencyPolicy() = default;

std::unique_ptr<MetricsScopesConnectionIdempotencyPolicy>
MetricsScopesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<MetricsScopesConnectionIdempotencyPolicy>(*this);
}

Idempotency MetricsScopesConnectionIdempotencyPolicy::GetMetricsScope(
    google::monitoring::metricsscope::v1::GetMetricsScopeRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
MetricsScopesConnectionIdempotencyPolicy::ListMetricsScopesByMonitoredProject(
    google::monitoring::metricsscope::v1::
        ListMetricsScopesByMonitoredProjectRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency MetricsScopesConnectionIdempotencyPolicy::CreateMonitoredProject(
    google::monitoring::metricsscope::v1::
        CreateMonitoredProjectRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency MetricsScopesConnectionIdempotencyPolicy::DeleteMonitoredProject(
    google::monitoring::metricsscope::v1::
        DeleteMonitoredProjectRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<MetricsScopesConnectionIdempotencyPolicy>
MakeDefaultMetricsScopesConnectionIdempotencyPolicy() {
  return std::make_unique<MetricsScopesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace monitoring_metricsscope_v1
}  // namespace cloud
}  // namespace google
