// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/monitoring/v3/snooze_service.proto

#include "google/cloud/monitoring/v3/snooze_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace monitoring_v3 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

SnoozeServiceConnectionIdempotencyPolicy::
    ~SnoozeServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<SnoozeServiceConnectionIdempotencyPolicy>
SnoozeServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<SnoozeServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency SnoozeServiceConnectionIdempotencyPolicy::CreateSnooze(
    google::monitoring::v3::CreateSnoozeRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SnoozeServiceConnectionIdempotencyPolicy::ListSnoozes(
    google::monitoring::v3::ListSnoozesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency SnoozeServiceConnectionIdempotencyPolicy::GetSnooze(
    google::monitoring::v3::GetSnoozeRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency SnoozeServiceConnectionIdempotencyPolicy::UpdateSnooze(
    google::monitoring::v3::UpdateSnoozeRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<SnoozeServiceConnectionIdempotencyPolicy>
MakeDefaultSnoozeServiceConnectionIdempotencyPolicy() {
  return std::make_unique<SnoozeServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace monitoring_v3
}  // namespace cloud
}  // namespace google
