// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/networkservices/v1/network_services.proto

#include "google/cloud/networkservices/v1/internal/network_services_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace networkservices_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

NetworkServicesTracingConnection::NetworkServicesTracingConnection(
    std::shared_ptr<networkservices_v1::NetworkServicesConnection> child)
    : child_(std::move(child)) {}

StreamRange<google::cloud::networkservices::v1::EndpointPolicy>
NetworkServicesTracingConnection::ListEndpointPolicies(
    google::cloud::networkservices::v1::ListEndpointPoliciesRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListEndpointPolicies");
  internal::OTelScope scope(span);
  auto sr = child_->ListEndpointPolicies(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::networkservices::v1::EndpointPolicy>(std::move(span),
                                                          std::move(sr));
}

StatusOr<google::cloud::networkservices::v1::EndpointPolicy>
NetworkServicesTracingConnection::GetEndpointPolicy(
    google::cloud::networkservices::v1::GetEndpointPolicyRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetEndpointPolicy");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetEndpointPolicy(request));
}

future<StatusOr<google::cloud::networkservices::v1::EndpointPolicy>>
NetworkServicesTracingConnection::CreateEndpointPolicy(
    google::cloud::networkservices::v1::CreateEndpointPolicyRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateEndpointPolicy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->CreateEndpointPolicy(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::CreateEndpointPolicy(
    NoAwaitTag,
    google::cloud::networkservices::v1::CreateEndpointPolicyRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateEndpointPolicy");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->CreateEndpointPolicy(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::EndpointPolicy>>
NetworkServicesTracingConnection::CreateEndpointPolicy(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateEndpointPolicy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->CreateEndpointPolicy(operation));
}

future<StatusOr<google::cloud::networkservices::v1::EndpointPolicy>>
NetworkServicesTracingConnection::UpdateEndpointPolicy(
    google::cloud::networkservices::v1::UpdateEndpointPolicyRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateEndpointPolicy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->UpdateEndpointPolicy(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::UpdateEndpointPolicy(
    NoAwaitTag,
    google::cloud::networkservices::v1::UpdateEndpointPolicyRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateEndpointPolicy");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->UpdateEndpointPolicy(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::EndpointPolicy>>
NetworkServicesTracingConnection::UpdateEndpointPolicy(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateEndpointPolicy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->UpdateEndpointPolicy(operation));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteEndpointPolicy(
    google::cloud::networkservices::v1::DeleteEndpointPolicyRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteEndpointPolicy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteEndpointPolicy(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::DeleteEndpointPolicy(
    NoAwaitTag,
    google::cloud::networkservices::v1::DeleteEndpointPolicyRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteEndpointPolicy");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->DeleteEndpointPolicy(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteEndpointPolicy(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteEndpointPolicy");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteEndpointPolicy(operation));
}

StreamRange<google::cloud::networkservices::v1::Gateway>
NetworkServicesTracingConnection::ListGateways(
    google::cloud::networkservices::v1::ListGatewaysRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListGateways");
  internal::OTelScope scope(span);
  auto sr = child_->ListGateways(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::networkservices::v1::Gateway>(std::move(span),
                                                   std::move(sr));
}

StatusOr<google::cloud::networkservices::v1::Gateway>
NetworkServicesTracingConnection::GetGateway(
    google::cloud::networkservices::v1::GetGatewayRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetGateway");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetGateway(request));
}

future<StatusOr<google::cloud::networkservices::v1::Gateway>>
NetworkServicesTracingConnection::CreateGateway(
    google::cloud::networkservices::v1::CreateGatewayRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateGateway");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateGateway(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::CreateGateway(
    NoAwaitTag,
    google::cloud::networkservices::v1::CreateGatewayRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateGateway");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span, child_->CreateGateway(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::Gateway>>
NetworkServicesTracingConnection::CreateGateway(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateGateway");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateGateway(operation));
}

future<StatusOr<google::cloud::networkservices::v1::Gateway>>
NetworkServicesTracingConnection::UpdateGateway(
    google::cloud::networkservices::v1::UpdateGatewayRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateGateway");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateGateway(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::UpdateGateway(
    NoAwaitTag,
    google::cloud::networkservices::v1::UpdateGatewayRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateGateway");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span, child_->UpdateGateway(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::Gateway>>
NetworkServicesTracingConnection::UpdateGateway(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateGateway");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateGateway(operation));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteGateway(
    google::cloud::networkservices::v1::DeleteGatewayRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteGateway");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteGateway(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::DeleteGateway(
    NoAwaitTag,
    google::cloud::networkservices::v1::DeleteGatewayRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteGateway");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span, child_->DeleteGateway(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteGateway(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteGateway");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteGateway(operation));
}

StreamRange<google::cloud::networkservices::v1::GrpcRoute>
NetworkServicesTracingConnection::ListGrpcRoutes(
    google::cloud::networkservices::v1::ListGrpcRoutesRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListGrpcRoutes");
  internal::OTelScope scope(span);
  auto sr = child_->ListGrpcRoutes(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::networkservices::v1::GrpcRoute>(std::move(span),
                                                     std::move(sr));
}

StatusOr<google::cloud::networkservices::v1::GrpcRoute>
NetworkServicesTracingConnection::GetGrpcRoute(
    google::cloud::networkservices::v1::GetGrpcRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetGrpcRoute");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetGrpcRoute(request));
}

future<StatusOr<google::cloud::networkservices::v1::GrpcRoute>>
NetworkServicesTracingConnection::CreateGrpcRoute(
    google::cloud::networkservices::v1::CreateGrpcRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateGrpcRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateGrpcRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::CreateGrpcRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::CreateGrpcRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateGrpcRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->CreateGrpcRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::GrpcRoute>>
NetworkServicesTracingConnection::CreateGrpcRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateGrpcRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateGrpcRoute(operation));
}

future<StatusOr<google::cloud::networkservices::v1::GrpcRoute>>
NetworkServicesTracingConnection::UpdateGrpcRoute(
    google::cloud::networkservices::v1::UpdateGrpcRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateGrpcRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateGrpcRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::UpdateGrpcRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::UpdateGrpcRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateGrpcRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->UpdateGrpcRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::GrpcRoute>>
NetworkServicesTracingConnection::UpdateGrpcRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateGrpcRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateGrpcRoute(operation));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteGrpcRoute(
    google::cloud::networkservices::v1::DeleteGrpcRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteGrpcRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteGrpcRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::DeleteGrpcRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::DeleteGrpcRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteGrpcRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->DeleteGrpcRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteGrpcRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteGrpcRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteGrpcRoute(operation));
}

StreamRange<google::cloud::networkservices::v1::HttpRoute>
NetworkServicesTracingConnection::ListHttpRoutes(
    google::cloud::networkservices::v1::ListHttpRoutesRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListHttpRoutes");
  internal::OTelScope scope(span);
  auto sr = child_->ListHttpRoutes(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::networkservices::v1::HttpRoute>(std::move(span),
                                                     std::move(sr));
}

StatusOr<google::cloud::networkservices::v1::HttpRoute>
NetworkServicesTracingConnection::GetHttpRoute(
    google::cloud::networkservices::v1::GetHttpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetHttpRoute");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetHttpRoute(request));
}

future<StatusOr<google::cloud::networkservices::v1::HttpRoute>>
NetworkServicesTracingConnection::CreateHttpRoute(
    google::cloud::networkservices::v1::CreateHttpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateHttpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateHttpRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::CreateHttpRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::CreateHttpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateHttpRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->CreateHttpRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::HttpRoute>>
NetworkServicesTracingConnection::CreateHttpRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateHttpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateHttpRoute(operation));
}

future<StatusOr<google::cloud::networkservices::v1::HttpRoute>>
NetworkServicesTracingConnection::UpdateHttpRoute(
    google::cloud::networkservices::v1::UpdateHttpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateHttpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateHttpRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::UpdateHttpRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::UpdateHttpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateHttpRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->UpdateHttpRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::HttpRoute>>
NetworkServicesTracingConnection::UpdateHttpRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateHttpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateHttpRoute(operation));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteHttpRoute(
    google::cloud::networkservices::v1::DeleteHttpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteHttpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteHttpRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::DeleteHttpRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::DeleteHttpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteHttpRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->DeleteHttpRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteHttpRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteHttpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteHttpRoute(operation));
}

StreamRange<google::cloud::networkservices::v1::TcpRoute>
NetworkServicesTracingConnection::ListTcpRoutes(
    google::cloud::networkservices::v1::ListTcpRoutesRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListTcpRoutes");
  internal::OTelScope scope(span);
  auto sr = child_->ListTcpRoutes(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::networkservices::v1::TcpRoute>(std::move(span),
                                                    std::move(sr));
}

StatusOr<google::cloud::networkservices::v1::TcpRoute>
NetworkServicesTracingConnection::GetTcpRoute(
    google::cloud::networkservices::v1::GetTcpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetTcpRoute");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetTcpRoute(request));
}

future<StatusOr<google::cloud::networkservices::v1::TcpRoute>>
NetworkServicesTracingConnection::CreateTcpRoute(
    google::cloud::networkservices::v1::CreateTcpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateTcpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateTcpRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::CreateTcpRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::CreateTcpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateTcpRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->CreateTcpRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::TcpRoute>>
NetworkServicesTracingConnection::CreateTcpRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateTcpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateTcpRoute(operation));
}

future<StatusOr<google::cloud::networkservices::v1::TcpRoute>>
NetworkServicesTracingConnection::UpdateTcpRoute(
    google::cloud::networkservices::v1::UpdateTcpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateTcpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateTcpRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::UpdateTcpRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::UpdateTcpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateTcpRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->UpdateTcpRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::TcpRoute>>
NetworkServicesTracingConnection::UpdateTcpRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateTcpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateTcpRoute(operation));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteTcpRoute(
    google::cloud::networkservices::v1::DeleteTcpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteTcpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteTcpRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::DeleteTcpRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::DeleteTcpRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteTcpRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->DeleteTcpRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteTcpRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteTcpRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteTcpRoute(operation));
}

StreamRange<google::cloud::networkservices::v1::TlsRoute>
NetworkServicesTracingConnection::ListTlsRoutes(
    google::cloud::networkservices::v1::ListTlsRoutesRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListTlsRoutes");
  internal::OTelScope scope(span);
  auto sr = child_->ListTlsRoutes(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::networkservices::v1::TlsRoute>(std::move(span),
                                                    std::move(sr));
}

StatusOr<google::cloud::networkservices::v1::TlsRoute>
NetworkServicesTracingConnection::GetTlsRoute(
    google::cloud::networkservices::v1::GetTlsRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetTlsRoute");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetTlsRoute(request));
}

future<StatusOr<google::cloud::networkservices::v1::TlsRoute>>
NetworkServicesTracingConnection::CreateTlsRoute(
    google::cloud::networkservices::v1::CreateTlsRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateTlsRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateTlsRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::CreateTlsRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::CreateTlsRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateTlsRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->CreateTlsRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::TlsRoute>>
NetworkServicesTracingConnection::CreateTlsRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateTlsRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateTlsRoute(operation));
}

future<StatusOr<google::cloud::networkservices::v1::TlsRoute>>
NetworkServicesTracingConnection::UpdateTlsRoute(
    google::cloud::networkservices::v1::UpdateTlsRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateTlsRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateTlsRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::UpdateTlsRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::UpdateTlsRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateTlsRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->UpdateTlsRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::TlsRoute>>
NetworkServicesTracingConnection::UpdateTlsRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateTlsRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateTlsRoute(operation));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteTlsRoute(
    google::cloud::networkservices::v1::DeleteTlsRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteTlsRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteTlsRoute(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::DeleteTlsRoute(
    NoAwaitTag,
    google::cloud::networkservices::v1::DeleteTlsRouteRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteTlsRoute");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->DeleteTlsRoute(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteTlsRoute(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteTlsRoute");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteTlsRoute(operation));
}

StreamRange<google::cloud::networkservices::v1::ServiceBinding>
NetworkServicesTracingConnection::ListServiceBindings(
    google::cloud::networkservices::v1::ListServiceBindingsRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListServiceBindings");
  internal::OTelScope scope(span);
  auto sr = child_->ListServiceBindings(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::networkservices::v1::ServiceBinding>(std::move(span),
                                                          std::move(sr));
}

StatusOr<google::cloud::networkservices::v1::ServiceBinding>
NetworkServicesTracingConnection::GetServiceBinding(
    google::cloud::networkservices::v1::GetServiceBindingRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetServiceBinding");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetServiceBinding(request));
}

future<StatusOr<google::cloud::networkservices::v1::ServiceBinding>>
NetworkServicesTracingConnection::CreateServiceBinding(
    google::cloud::networkservices::v1::CreateServiceBindingRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateServiceBinding");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->CreateServiceBinding(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::CreateServiceBinding(
    NoAwaitTag,
    google::cloud::networkservices::v1::CreateServiceBindingRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateServiceBinding");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->CreateServiceBinding(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::ServiceBinding>>
NetworkServicesTracingConnection::CreateServiceBinding(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateServiceBinding");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->CreateServiceBinding(operation));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteServiceBinding(
    google::cloud::networkservices::v1::DeleteServiceBindingRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteServiceBinding");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteServiceBinding(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::DeleteServiceBinding(
    NoAwaitTag,
    google::cloud::networkservices::v1::DeleteServiceBindingRequest const&
        request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteServiceBinding");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span,
                           child_->DeleteServiceBinding(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteServiceBinding(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteServiceBinding");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteServiceBinding(operation));
}

StreamRange<google::cloud::networkservices::v1::Mesh>
NetworkServicesTracingConnection::ListMeshes(
    google::cloud::networkservices::v1::ListMeshesRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListMeshes");
  internal::OTelScope scope(span);
  auto sr = child_->ListMeshes(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::networkservices::v1::Mesh>(std::move(span), std::move(sr));
}

StatusOr<google::cloud::networkservices::v1::Mesh>
NetworkServicesTracingConnection::GetMesh(
    google::cloud::networkservices::v1::GetMeshRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetMesh");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetMesh(request));
}

future<StatusOr<google::cloud::networkservices::v1::Mesh>>
NetworkServicesTracingConnection::CreateMesh(
    google::cloud::networkservices::v1::CreateMeshRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateMesh");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateMesh(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::CreateMesh(
    NoAwaitTag,
    google::cloud::networkservices::v1::CreateMeshRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateMesh");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span, child_->CreateMesh(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::Mesh>>
NetworkServicesTracingConnection::CreateMesh(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CreateMesh");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->CreateMesh(operation));
}

future<StatusOr<google::cloud::networkservices::v1::Mesh>>
NetworkServicesTracingConnection::UpdateMesh(
    google::cloud::networkservices::v1::UpdateMeshRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateMesh");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateMesh(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::UpdateMesh(
    NoAwaitTag,
    google::cloud::networkservices::v1::UpdateMeshRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateMesh");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span, child_->UpdateMesh(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::Mesh>>
NetworkServicesTracingConnection::UpdateMesh(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::UpdateMesh");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->UpdateMesh(operation));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteMesh(
    google::cloud::networkservices::v1::DeleteMeshRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteMesh");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteMesh(request));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::DeleteMesh(
    NoAwaitTag,
    google::cloud::networkservices::v1::DeleteMeshRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteMesh");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(*span, child_->DeleteMesh(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>
NetworkServicesTracingConnection::DeleteMesh(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteMesh");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span), child_->DeleteMesh(operation));
}

StreamRange<google::cloud::location::Location>
NetworkServicesTracingConnection::ListLocations(
    google::cloud::location::ListLocationsRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListLocations");
  internal::OTelScope scope(span);
  auto sr = child_->ListLocations(std::move(request));
  return internal::MakeTracedStreamRange<google::cloud::location::Location>(
      std::move(span), std::move(sr));
}

StatusOr<google::cloud::location::Location>
NetworkServicesTracingConnection::GetLocation(
    google::cloud::location::GetLocationRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetLocation");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetLocation(request));
}

StatusOr<google::iam::v1::Policy>
NetworkServicesTracingConnection::SetIamPolicy(
    google::iam::v1::SetIamPolicyRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::SetIamPolicy");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->SetIamPolicy(request));
}

StatusOr<google::iam::v1::Policy>
NetworkServicesTracingConnection::GetIamPolicy(
    google::iam::v1::GetIamPolicyRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetIamPolicy");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetIamPolicy(request));
}

StatusOr<google::iam::v1::TestIamPermissionsResponse>
NetworkServicesTracingConnection::TestIamPermissions(
    google::iam::v1::TestIamPermissionsRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::TestIamPermissions");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->TestIamPermissions(request));
}

StreamRange<google::longrunning::Operation>
NetworkServicesTracingConnection::ListOperations(
    google::longrunning::ListOperationsRequest request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::ListOperations");
  internal::OTelScope scope(span);
  auto sr = child_->ListOperations(std::move(request));
  return internal::MakeTracedStreamRange<google::longrunning::Operation>(
      std::move(span), std::move(sr));
}

StatusOr<google::longrunning::Operation>
NetworkServicesTracingConnection::GetOperation(
    google::longrunning::GetOperationRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::GetOperation");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetOperation(request));
}

Status NetworkServicesTracingConnection::DeleteOperation(
    google::longrunning::DeleteOperationRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::DeleteOperation");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->DeleteOperation(request));
}

Status NetworkServicesTracingConnection::CancelOperation(
    google::longrunning::CancelOperationRequest const& request) {
  auto span = internal::MakeSpan(
      "networkservices_v1::NetworkServicesConnection::CancelOperation");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->CancelOperation(request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<networkservices_v1::NetworkServicesConnection>
MakeNetworkServicesTracingConnection(
    std::shared_ptr<networkservices_v1::NetworkServicesConnection> conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<NetworkServicesTracingConnection>(std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace networkservices_v1_internal
}  // namespace cloud
}  // namespace google
