// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/osconfig/agentendpoint/v1/agentendpoint.proto

#include "google/cloud/osconfig/agentendpoint/v1/agent_endpoint_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace osconfig_agentendpoint_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

AgentEndpointServiceConnectionIdempotencyPolicy::
    ~AgentEndpointServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<AgentEndpointServiceConnectionIdempotencyPolicy>
AgentEndpointServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<AgentEndpointServiceConnectionIdempotencyPolicy>(
      *this);
}

Idempotency AgentEndpointServiceConnectionIdempotencyPolicy::StartNextTask(
    google::cloud::osconfig::agentendpoint::v1::StartNextTaskRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency AgentEndpointServiceConnectionIdempotencyPolicy::ReportTaskProgress(
    google::cloud::osconfig::agentendpoint::v1::
        ReportTaskProgressRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency AgentEndpointServiceConnectionIdempotencyPolicy::ReportTaskComplete(
    google::cloud::osconfig::agentendpoint::v1::
        ReportTaskCompleteRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency AgentEndpointServiceConnectionIdempotencyPolicy::RegisterAgent(
    google::cloud::osconfig::agentendpoint::v1::RegisterAgentRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency AgentEndpointServiceConnectionIdempotencyPolicy::ReportInventory(
    google::cloud::osconfig::agentendpoint::v1::ReportInventoryRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<AgentEndpointServiceConnectionIdempotencyPolicy>
MakeDefaultAgentEndpointServiceConnectionIdempotencyPolicy() {
  return std::make_unique<AgentEndpointServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace osconfig_agentendpoint_v1
}  // namespace cloud
}  // namespace google
