// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/oslogin/v1/oslogin.proto

#include "google/cloud/oslogin/v1/internal/os_login_option_defaults.h"
#include "google/cloud/oslogin/v1/os_login_connection.h"
#include "google/cloud/oslogin/v1/os_login_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace oslogin_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options OsLoginServiceDefaultOptions(Options options) {
  options = internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_OS_LOGIN_SERVICE_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_OS_LOGIN_SERVICE_AUTHORITY", "oslogin.googleapis.com");
  options = internal::PopulateGrpcOptions(std::move(options));
  if (!options.has<oslogin_v1::OsLoginServiceRetryPolicyOption>()) {
    options.set<oslogin_v1::OsLoginServiceRetryPolicyOption>(
        oslogin_v1::OsLoginServiceLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<oslogin_v1::OsLoginServiceBackoffPolicyOption>()) {
    options.set<oslogin_v1::OsLoginServiceBackoffPolicyOption>(
        ExponentialBackoffPolicy(
            std::chrono::seconds(0), std::chrono::seconds(1),
            std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
            .clone());
  }
  if (!options.has<
          oslogin_v1::OsLoginServiceConnectionIdempotencyPolicyOption>()) {
    options.set<oslogin_v1::OsLoginServiceConnectionIdempotencyPolicyOption>(
        oslogin_v1::MakeDefaultOsLoginServiceConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace oslogin_v1_internal
}  // namespace cloud
}  // namespace google
