// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/security/publicca/v1/service.proto

#include "google/cloud/publicca/v1/public_certificate_authority_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace publicca_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

PublicCertificateAuthorityServiceConnectionIdempotencyPolicy::
    ~PublicCertificateAuthorityServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<PublicCertificateAuthorityServiceConnectionIdempotencyPolicy>
PublicCertificateAuthorityServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<
      PublicCertificateAuthorityServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency PublicCertificateAuthorityServiceConnectionIdempotencyPolicy::
    CreateExternalAccountKey(google::cloud::security::publicca::v1::
                                 CreateExternalAccountKeyRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<PublicCertificateAuthorityServiceConnectionIdempotencyPolicy>
MakeDefaultPublicCertificateAuthorityServiceConnectionIdempotencyPolicy() {
  return std::make_unique<
      PublicCertificateAuthorityServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace publicca_v1
}  // namespace cloud
}  // namespace google
