// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/redis/cluster/v1/cloud_redis_cluster.proto

#include "google/cloud/redis/cluster/v1/cloud_redis_cluster_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace redis_cluster_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

CloudRedisClusterConnectionIdempotencyPolicy::
    ~CloudRedisClusterConnectionIdempotencyPolicy() = default;

std::unique_ptr<CloudRedisClusterConnectionIdempotencyPolicy>
CloudRedisClusterConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<CloudRedisClusterConnectionIdempotencyPolicy>(*this);
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::ListClusters(
    google::cloud::redis::cluster::v1::ListClustersRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::GetCluster(
    google::cloud::redis::cluster::v1::GetClusterRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::UpdateCluster(
    google::cloud::redis::cluster::v1::UpdateClusterRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::DeleteCluster(
    google::cloud::redis::cluster::v1::DeleteClusterRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::CreateCluster(
    google::cloud::redis::cluster::v1::CreateClusterRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
CloudRedisClusterConnectionIdempotencyPolicy::GetClusterCertificateAuthority(
    google::cloud::redis::cluster::v1::
        GetClusterCertificateAuthorityRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
CloudRedisClusterConnectionIdempotencyPolicy::RescheduleClusterMaintenance(
    google::cloud::redis::cluster::v1::
        RescheduleClusterMaintenanceRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::ListBackupCollections(
    google::cloud::redis::cluster::v1::
        ListBackupCollectionsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::GetBackupCollection(
    google::cloud::redis::cluster::v1::GetBackupCollectionRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::ListBackups(
    google::cloud::redis::cluster::v1::ListBackupsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::GetBackup(
    google::cloud::redis::cluster::v1::GetBackupRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::DeleteBackup(
    google::cloud::redis::cluster::v1::DeleteBackupRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::ExportBackup(
    google::cloud::redis::cluster::v1::ExportBackupRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::BackupCluster(
    google::cloud::redis::cluster::v1::BackupClusterRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::ListLocations(
    google::cloud::location::ListLocationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::GetLocation(
    google::cloud::location::GetLocationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::ListOperations(
    google::longrunning::ListOperationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::DeleteOperation(
    google::longrunning::DeleteOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency CloudRedisClusterConnectionIdempotencyPolicy::CancelOperation(
    google::longrunning::CancelOperationRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<CloudRedisClusterConnectionIdempotencyPolicy>
MakeDefaultCloudRedisClusterConnectionIdempotencyPolicy() {
  return std::make_unique<CloudRedisClusterConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace redis_cluster_v1
}  // namespace cloud
}  // namespace google
