// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/retail/v2/analytics_service.proto

#include "google/cloud/retail/v2/internal/analytics_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace retail_v2_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

AnalyticsServiceTracingConnection::AnalyticsServiceTracingConnection(
    std::shared_ptr<retail_v2::AnalyticsServiceConnection> child)
    : child_(std::move(child)) {}

future<StatusOr<google::cloud::retail::v2::ExportAnalyticsMetricsResponse>>
AnalyticsServiceTracingConnection::ExportAnalyticsMetrics(
    google::cloud::retail::v2::ExportAnalyticsMetricsRequest const& request) {
  auto span = internal::MakeSpan(
      "retail_v2::AnalyticsServiceConnection::ExportAnalyticsMetrics");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->ExportAnalyticsMetrics(request));
}

StatusOr<google::longrunning::Operation>
AnalyticsServiceTracingConnection::ExportAnalyticsMetrics(
    NoAwaitTag,
    google::cloud::retail::v2::ExportAnalyticsMetricsRequest const& request) {
  auto span = internal::MakeSpan(
      "retail_v2::AnalyticsServiceConnection::ExportAnalyticsMetrics");
  opentelemetry::trace::Scope scope(span);
  return internal::EndSpan(
      *span, child_->ExportAnalyticsMetrics(NoAwaitTag{}, request));
}

future<StatusOr<google::cloud::retail::v2::ExportAnalyticsMetricsResponse>>
AnalyticsServiceTracingConnection::ExportAnalyticsMetrics(
    google::longrunning::Operation const& operation) {
  auto span = internal::MakeSpan(
      "retail_v2::AnalyticsServiceConnection::ExportAnalyticsMetrics");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->ExportAnalyticsMetrics(operation));
}

StreamRange<google::longrunning::Operation>
AnalyticsServiceTracingConnection::ListOperations(
    google::longrunning::ListOperationsRequest request) {
  auto span = internal::MakeSpan(
      "retail_v2::AnalyticsServiceConnection::ListOperations");
  internal::OTelScope scope(span);
  auto sr = child_->ListOperations(std::move(request));
  return internal::MakeTracedStreamRange<google::longrunning::Operation>(
      std::move(span), std::move(sr));
}

StatusOr<google::longrunning::Operation>
AnalyticsServiceTracingConnection::GetOperation(
    google::longrunning::GetOperationRequest const& request) {
  auto span =
      internal::MakeSpan("retail_v2::AnalyticsServiceConnection::GetOperation");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetOperation(request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<retail_v2::AnalyticsServiceConnection>
MakeAnalyticsServiceTracingConnection(
    std::shared_ptr<retail_v2::AnalyticsServiceConnection> conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<AnalyticsServiceTracingConnection>(std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace retail_v2_internal
}  // namespace cloud
}  // namespace google
