// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/speech/v1/cloud_speech.proto

#include "google/cloud/speech/v1/speech_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace speech_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

SpeechConnectionIdempotencyPolicy::~SpeechConnectionIdempotencyPolicy() =
    default;

std::unique_ptr<SpeechConnectionIdempotencyPolicy>
SpeechConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<SpeechConnectionIdempotencyPolicy>(*this);
}

Idempotency SpeechConnectionIdempotencyPolicy::Recognize(
    google::cloud::speech::v1::RecognizeRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SpeechConnectionIdempotencyPolicy::LongRunningRecognize(
    google::cloud::speech::v1::LongRunningRecognizeRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency SpeechConnectionIdempotencyPolicy::ListOperations(
    google::longrunning::ListOperationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency SpeechConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

std::unique_ptr<SpeechConnectionIdempotencyPolicy>
MakeDefaultSpeechConnectionIdempotencyPolicy() {
  return std::make_unique<SpeechConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace speech_v1
}  // namespace cloud
}  // namespace google
