// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/support/v2/case_service.proto

#include "google/cloud/support/v2/internal/case_auth_decorator.h"
#include <google/cloud/support/v2/case_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace support_v2_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

CaseServiceAuth::CaseServiceAuth(
    std::shared_ptr<google::cloud::internal::GrpcAuthenticationStrategy> auth,
    std::shared_ptr<CaseServiceStub> child)
    : auth_(std::move(auth)), child_(std::move(child)) {}

StatusOr<google::cloud::support::v2::Case> CaseServiceAuth::GetCase(
    grpc::ClientContext& context, Options const& options,
    google::cloud::support::v2::GetCaseRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->GetCase(context, options, request);
}

StatusOr<google::cloud::support::v2::ListCasesResponse>
CaseServiceAuth::ListCases(
    grpc::ClientContext& context, Options const& options,
    google::cloud::support::v2::ListCasesRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->ListCases(context, options, request);
}

StatusOr<google::cloud::support::v2::SearchCasesResponse>
CaseServiceAuth::SearchCases(
    grpc::ClientContext& context, Options const& options,
    google::cloud::support::v2::SearchCasesRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->SearchCases(context, options, request);
}

StatusOr<google::cloud::support::v2::Case> CaseServiceAuth::CreateCase(
    grpc::ClientContext& context, Options const& options,
    google::cloud::support::v2::CreateCaseRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->CreateCase(context, options, request);
}

StatusOr<google::cloud::support::v2::Case> CaseServiceAuth::UpdateCase(
    grpc::ClientContext& context, Options const& options,
    google::cloud::support::v2::UpdateCaseRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->UpdateCase(context, options, request);
}

StatusOr<google::cloud::support::v2::Case> CaseServiceAuth::EscalateCase(
    grpc::ClientContext& context, Options const& options,
    google::cloud::support::v2::EscalateCaseRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->EscalateCase(context, options, request);
}

StatusOr<google::cloud::support::v2::Case> CaseServiceAuth::CloseCase(
    grpc::ClientContext& context, Options const& options,
    google::cloud::support::v2::CloseCaseRequest const& request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->CloseCase(context, options, request);
}

StatusOr<google::cloud::support::v2::SearchCaseClassificationsResponse>
CaseServiceAuth::SearchCaseClassifications(
    grpc::ClientContext& context, Options const& options,
    google::cloud::support::v2::SearchCaseClassificationsRequest const&
        request) {
  auto status = auth_->ConfigureContext(context);
  if (!status.ok()) return status;
  return child_->SearchCaseClassifications(context, options, request);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace support_v2_internal
}  // namespace cloud
}  // namespace google
