// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/timeseriesinsights/v1/timeseries_insights.proto

#include "google/cloud/timeseriesinsights/v1/timeseries_insights_controller_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace timeseriesinsights_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

TimeseriesInsightsControllerConnectionIdempotencyPolicy::
    ~TimeseriesInsightsControllerConnectionIdempotencyPolicy() = default;

std::unique_ptr<TimeseriesInsightsControllerConnectionIdempotencyPolicy>
TimeseriesInsightsControllerConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<
      TimeseriesInsightsControllerConnectionIdempotencyPolicy>(*this);
}

Idempotency
TimeseriesInsightsControllerConnectionIdempotencyPolicy::ListDataSets(
    google::cloud::timeseriesinsights::v1::ListDataSetsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
TimeseriesInsightsControllerConnectionIdempotencyPolicy::CreateDataSet(
    google::cloud::timeseriesinsights::v1::CreateDataSetRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
TimeseriesInsightsControllerConnectionIdempotencyPolicy::DeleteDataSet(
    google::cloud::timeseriesinsights::v1::DeleteDataSetRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
TimeseriesInsightsControllerConnectionIdempotencyPolicy::AppendEvents(
    google::cloud::timeseriesinsights::v1::AppendEventsRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
TimeseriesInsightsControllerConnectionIdempotencyPolicy::QueryDataSet(
    google::cloud::timeseriesinsights::v1::QueryDataSetRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
TimeseriesInsightsControllerConnectionIdempotencyPolicy::EvaluateSlice(
    google::cloud::timeseriesinsights::v1::EvaluateSliceRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
TimeseriesInsightsControllerConnectionIdempotencyPolicy::EvaluateTimeseries(
    google::cloud::timeseriesinsights::v1::EvaluateTimeseriesRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<TimeseriesInsightsControllerConnectionIdempotencyPolicy>
MakeDefaultTimeseriesInsightsControllerConnectionIdempotencyPolicy() {
  return std::make_unique<
      TimeseriesInsightsControllerConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace timeseriesinsights_v1
}  // namespace cloud
}  // namespace google
