// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/vpcaccess/v1/vpc_access.proto

#include "google/cloud/vpcaccess/v1/vpc_access_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace vpcaccess_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

VpcAccessServiceConnectionIdempotencyPolicy::
    ~VpcAccessServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<VpcAccessServiceConnectionIdempotencyPolicy>
VpcAccessServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<VpcAccessServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency VpcAccessServiceConnectionIdempotencyPolicy::CreateConnector(
    google::cloud::vpcaccess::v1::CreateConnectorRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency VpcAccessServiceConnectionIdempotencyPolicy::GetConnector(
    google::cloud::vpcaccess::v1::GetConnectorRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency VpcAccessServiceConnectionIdempotencyPolicy::ListConnectors(
    google::cloud::vpcaccess::v1::ListConnectorsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency VpcAccessServiceConnectionIdempotencyPolicy::DeleteConnector(
    google::cloud::vpcaccess::v1::DeleteConnectorRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency VpcAccessServiceConnectionIdempotencyPolicy::ListLocations(
    google::cloud::location::ListLocationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency VpcAccessServiceConnectionIdempotencyPolicy::ListOperations(
    google::longrunning::ListOperationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency VpcAccessServiceConnectionIdempotencyPolicy::GetOperation(
    google::longrunning::GetOperationRequest const&) {
  return Idempotency::kIdempotent;
}

std::unique_ptr<VpcAccessServiceConnectionIdempotencyPolicy>
MakeDefaultVpcAccessServiceConnectionIdempotencyPolicy() {
  return std::make_unique<VpcAccessServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace vpcaccess_v1
}  // namespace cloud
}  // namespace google
