// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/workflows/executions/v1/executions.proto

#include "google/cloud/workflows/executions/v1/executions_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace workflows_executions_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ExecutionsConnectionIdempotencyPolicy::
    ~ExecutionsConnectionIdempotencyPolicy() = default;

std::unique_ptr<ExecutionsConnectionIdempotencyPolicy>
ExecutionsConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<ExecutionsConnectionIdempotencyPolicy>(*this);
}

Idempotency ExecutionsConnectionIdempotencyPolicy::ListExecutions(
    google::cloud::workflows::executions::v1::
        ListExecutionsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency ExecutionsConnectionIdempotencyPolicy::CreateExecution(
    google::cloud::workflows::executions::v1::CreateExecutionRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ExecutionsConnectionIdempotencyPolicy::GetExecution(
    google::cloud::workflows::executions::v1::GetExecutionRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency ExecutionsConnectionIdempotencyPolicy::CancelExecution(
    google::cloud::workflows::executions::v1::CancelExecutionRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<ExecutionsConnectionIdempotencyPolicy>
MakeDefaultExecutionsConnectionIdempotencyPolicy() {
  return std::make_unique<ExecutionsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace workflows_executions_v1
}  // namespace cloud
}  // namespace google
